<?php
	if (!defined("ENV")) exit();
	unset($msg_alert);
	pageHeader("Import Email Addresses", "", "icb-envelope2-left");
	$action = empty($action)?"":$action;
	if ($action == "import")
	{
		switch ($separator)
		{
			case "line" : 
			{
				$s = explode("\n", $emails);
				break;
			}
			case "comma" : 
			{
				$s = explode(",", $emails);
				break;
			}
			case "semicolon" : 
			{
				$s = explode(";", $emails);
				break;
			}
		}
		$c_i = 0;
		$c_u = 0;
		for ($i=0; $i<count($s); $i++)
		{
			$e = strtolower(trim($s[$i]));
			if ($e != "")
			{
				$db->query("SELECT * FROM ".DB_PREFIX."emails WHERE email LIKE '".$db->escape($e)."'");
				if ($db->moveNext())
				{
					if (!DEMO_LOCK)
					{
						$eid = $db->col["eid"];
						$db->reset();
						$db->assignStr("dead", "No");
						$db->assignStr("newsletters", "Yes");
						$db->assignStr("updates", "Yes");
						$db->update(DB_PREFIX."emails", "WHERE eid='".$eid."'");
					}
					$c_u++;
				}
				else
				{
					if (!DEMO_LOCK)
					{
						$db->reset();
						$db->assign("added", "NOW()");
						$db->assignStr("email", $e);
						$db->assignStr("dead", "No");
						$db->assignStr("newsletters", "Yes");
						$db->assignStr("updates", "Yes");
						$db->insert(DB_PREFIX."emails");
						Newsletter_Connector::subscribe($e, 'html', true);
					}
					$c_i++;
				}
			}
		}
		$msg_alert[]= $c_i." Email addresses have been added to database, ".$c_u." were updated.";
		pageNote(array(
			array("class"=>"ic-info", "text"=>$c_i." email addresses have been added to database, ".$c_u." were updated.", "url"=>"", "visible"=>true)
		));
	}
	else
	{
		echo "&nbsp;";
	}
?>
<form action="admin.php?p=emails_import" method="post">
	<input type="hidden" name="action" value="import">
	<div class="admin-tabs admin-tabs-framed" id="tabs-import">
<?php 
	
	pageTabs(array(
		array("title"=>"Import Emails", "id"=>"main"),
	), "tabs-import", false);

?>
		<div id="admin-tab-sheet-main" class="admin-tab-sheet">
			<div class="admin-tab-sheet-wrap">
				<div class="admin-form-header first"><span class="icon ic-icon ic-upload"></span>Import Email Addresses</div>
				<table width="100%" cellpadding="0" cellspacing="0" border="0">
					<tr valign="top">
						<td class="formItemCaption">Choose Import Format</td>
						<td class="formItemControl">
							<select name="separator">
								<option value="line">Email per line</option>
								<option value="comma">Comma-separated (,)</option>
								<option value="semicolon">Semicolon-separated (;)</option>
							</select>
						</td>
					</tr>
					<tr valign="top">
						<td class="formItemCaption">Paste Email Addresses Here</td>
						<td class="formItemControl">
							<textarea class="no-mce" rows="20" cols="60" name="emails"></textarea>
						</td>
					</tr>
				</table>
			</div>
		</div>
	</div>
	<div class="admin-form-buttons">
		<input type="submit" value="Import emails"/>
		<input type="reset" value="Reset form"/>
	</div>
</form>