<?php

	$db->query('SELECT * FROM '.DB_PREFIX.'exactor_euc_categories ORDER BY parent, description');

	/**
	 * Option param
	 */
	class OPTION_PARAM
	{
		var $id;
		var $parent_id;
		var $level;
		
		function OPTION_PARAM($id, $parent_id, $level)
		{
			$this->id = $id;
			$this->parent_id = $parent_id;
			$this->level = $level;
			return $this;
		}
	}

	/**
	 * Option node
	 */
	class OPTION_NODE extends DB_TREE_NODE
	{
		public function drawNode($param)
		{
			if ($this->id!=$param->id)
			{
				if ($this->id != TREE_ROOT)
				{
					echo 
						str_repeat("\t", $param->level)."<li class=\"closed\">\n";

					echo str_repeat("\t", $param->level+1)."<a class=\"euc_category ".(count($this->nodes) > 0 ? 'parent': '').'" href="#" id="category-'.$this->id.'"><span>'.htmlspecialchars($this->caption)."</span></a>\n";
				
					if (count($this->nodes) > 0)
					{
						echo str_repeat("\t", $param->level+1)."<ul style=\"display:none;\">\n";
						foreach ($this->nodes as $id => $node)
						{
							$node->drawNode(
								new OPTION_PARAM($param->id, $param->parent_id, $param->level+1)
							);
						}
						echo str_repeat("\t", $param->level+1)."</ul>\n";
					}

					echo str_repeat("\t", $param->level)."</li>\n";
				}
				else
				{
					if (count($this->nodes) > 0)
					{
						foreach ($this->nodes as $id => $node)
						{
							$node->drawNode(
								new OPTION_PARAM($param->id, $param->parent_id, $param->level+1)
							);
						}
					}
				}
			}
		}
	}

	$tree = new DB_TREE();
	$tree->collection[TREE_ROOT] = (new OPTION_NODE(TREE_ROOT, -1, 0, "Yes", "Category Root"));
	while ($db->moveNext())
	{
		$tree->addNode(
			new OPTION_NODE(
				$db->col["id"], 
				intval($db->col["parent"]),
				$db->col["level"], 
				1,
				$db->col["description"]
			)
		);
	}
?>
<div>
	<div style="float:left;width:300px;">
		<ul class="tree">
			<?php
			$cid = -1;
			$parent = TREE_ROOT;
			$tree->collection[TREE_ROOT]->drawNode(
				new OPTION_PARAM($cid, $parent, 0)
			);
			?>
		</ul>
	</div>
	<div id="euc_products" style="float:left;width:300px;">
	</div>
	<div style="clear:both;"></div>
</div>
