<?php
	if (!defined("ENV")) exit();
	
	if (isset($_REQUEST['show_php_info']))
	{
		phpinfo(); exit;	
	}
	
	pageHeader("Your Shopping Cart Information", "", "icb-info");
	if(isset($_REQUEST["action"])) {
		switch ($_REQUEST["action"]){
			case "refresh_license" : {
				unlink("content/cache/license/license.key");
				//check for proxy settings for iono
				$iono->iono_keys_call4520(trim(LICENSE_NUMBER), "b575796b4295", 'content/cache/license/license.key', 604800); //172800 - 2 days
				if($iono->status == ""){
					$iono->get_status_1980();
				}
				if($iono->result != 1){
					echo '<script type="text/javascript">document.location="login.php";</script>';
				}
				break;
			}
		}
	}
?>
<br/>
<table cellpadding="0" cellspacing="0" border="0" width="100%" class="admin-list-table">
	<thead>
		<tr>
			<th class="icon"></th>
			<th>Parameter</th>
			<th>Value</th>
		</tr>
	</thead>
	<tbody>
		<tr>
			<td class="icon"><span class="icon ic-icon ic-gear"></span></td>
			<td>Application Version</td>
			<td><?php echo $settings["AppVer"]?></td>
		</tr>

		<tr>
			<td class="icon"><span class="icon ic-icon ic-gear"></span></td>
			<td>Encoder Used</td>
			<td><?php echo substr(trim(strtolower($settings["AppEncoder"])), 0, 7) == "ioncube"?"IonCube":"Zend";?></td>
		</tr>

		<tr>
		<td class="icon"><span class="icon ic-icon ic-gear"></span></td>
			<td>License Key</td>
			<td><?php echo LICENSE_NUMBER;?> - <a href="admin.php?p=info&action=refresh_license">Refresh License Information</a></td>
		</tr>

		<tr>
			<td class="icon"><span class="icon ic-icon ic-gear"></span></td>
			<td>Products Limit</td>
			<td><?php echo (''.AccessManager::checkAccess('MAX_PRODUCTS') == 'INF') ? "Unlimited" : AccessManager::checkAccess('MAX_PRODUCTS');?></td>
		</tr>

		<tr>
			<td class="icon"><span class="icon ic-icon ic-gear"></span></td>
			<td>Admins Limit</td>
			<td><?php echo (''.AccessManager::checkAccess('MAX_ADMINS') == 'INF') ? "Unlimited" : AccessManager::checkAccess('MAX_ADMINS');?></td>
		</tr>
		
		<tr>
			<td class="icon"><span class="icon ic-icon ic-gear"></span></td>
			<td>Server Software</td>
			<td><?php echo $_SERVER["SERVER_SOFTWARE"];?></td>
		</tr>
		
		<tr>
			<td class="icon"><span class="icon ic-icon ic-gear"></span></td>
			<td>Server Name</td>
			<td><?php echo $_SERVER["SERVER_NAME"];?></td>
		</tr>
		
		<tr>
			<td class="icon"><span class="icon ic-icon ic-gear"></span></td>
			<td>Server IP Address</td>
			<td><?php echo $_SERVER["SERVER_ADDR"];?></td>
		</tr>
		
		<tr>
			<td class="icon"><span class="icon ic-icon ic-gear"></span></td>
			<td>More Details</div>
			<td>
				<a id="showPhpInfo" href="#">Show more information</a>
			</td>
		</tr>
	</tbody>
</table>


<div id="phpInfo" style="display: none; height: 600px; width: 100%;">
	<iframe style="width: 100%; border: none; height: 100%;" src="admin.php?p=info&show_php_info=true&chart=true"></iframe>
</div>
<script type="text/javascript">
$(document).ready(function(){
	$('#phpInfo').dialog({
		'title': 'Server Information',
		'autoOpen': false,
		'height': 600,
		'width': 800,
		'resizable': false
	});
	var triggerPhpInfo = $('#showPhpInfo').click(function(){
		$('#phpInfo').dialog('open');
	});
});
</script>