<?php
	if (!defined("ENV")) exit();
	$pid = isset($pid)?trim($pid):"";
	$mode = isset($mode)?trim($mode):"";
	switch($mode)
	{
		case "update" : 
		{
			$db->query("SELECT * FROM ".DB_PREFIX."pages WHERE pid='".$pid."'");
			if ($db->moveNext())
			{
				$priority = $db->col["priority"];
				$is_visible = $db->col["is_active"];
				$options = $db->col["options"];
				$name = $db->col["name"];
				$caption = $db->col["title"];
				$content = $db->col["content"];
				$meta_keywords = $db->col["meta_keywords"];
				$meta_title = $db->col["meta_title"];
				$meta_description = $db->col["meta_description"];
				$url_default = $db->col["url_default"];
				$url_custom = $db->col["url_custom"];
				break;
			}
		}
		default :
		case "insert" : 
		{
			$mode = "insert";
			$tid = "";
			$priority = 5;
			$is_visible = "Yes";
			$options = "Top";
			$name = "";
			$caption = "";
			$content = "";
			$meta_keywords = "";
			$meta_title = "";
			$meta_description = "";
			$url_default = "";
			$url_custom = "";
		}
	}
	loadJS("cf_page.js");

	pageHeader("Site Page", $mode, "icb-document");
	pageNote(array(
		array("class"=>"ic-info", "text"=>"Use this section to add a custom page to your cart. To get the correct look, be sure to use HTML.", "url"=>"", "visible"=>true),
		array("class"=>"ic-monitor", "text"=>"Click here to edit Appearance Settings (Default Images, Layout and Colors)", "url"=>"admin.php?p=design_settings", "visible"=>true),
		array("class"=>"ic-info", "text"=>"To add images to this page, the images need to be moved to the  <br><u>".$settings["GlobalHttpUrl"]."/images/custom/</u><br>folder. You can do this moving the images via FTP, or <a href=\"javascript:showFileManager('/images/custom/');\">click here to use file manager</a>.<br>Remember, your HTML code needs to have the full path to the images.", "url"=>"", "visible"=>true),
		array("class"=>"ic-info", "text"=>"<b>Please note: required fields are bold</b>", "url"=>"", "visible"=>true)
	));
?>
<form name="frmPage" action="admin.php?p=page_process" method="post" onSubmit="return CheckPageForm(this)">
	<input type="hidden" name="pid" value="<?=$pid?>">
	<input type="hidden" name="mode" value="<?=$mode?>">
	<input type="hidden" name="nonce" value="<?=create_nonce('page_'.$mode)?>">
	<div class="admin-tabs admin-tabs-framed" id="tabs-page">
<?php 
	pageTabs(array(
		array("title"=>"Page Properties", "id"=>"main"),
	), "tabs-page");
?>
		<div id="admin-tab-sheet-main" class="admin-tab-sheet">
			<div class="admin-tab-sheet-wrap">
				<div class="admin-form-header first"><span class="icon ic-icon ic-document"></span>Common Page Information</div>
				<table width="100%" cellpadding="0" cellspacing="0" border="0">
					<tr valign="top">
						<td class="formItemCaption"><span class="required">Short Name</span> <i>(example: page_name)</i></td>
						<td class="formItemControl"><input type="text" name="name" value="<?=htmlspecialchars($name)?>"/></td>
					</tr>
					<tr valign="top">
						<td class="formItemCaption"><span class="required">Page Title</span> <i>(for Menu)</i></td>
						<td class="formItemControl"><input type="text" name="caption" value="<?=htmlspecialchars($caption)?>"/></td>
					</tr>
					<tr valign="top">
						<td class="formItemCaption">Is this page visible?</td>
						<td class="formItemControl">
							<select name="is_visible" class="short">
								<option value="Yes">Yes</option>
								<option value="No" <?=$is_visible=="No"?"selected":""?>>No</option>
							</select>
						</td>
					</tr>
					<tr valign="top">
						<td class="formItemCaption">Priority (used for sorting)</td>
						<td class="formItemControl">
							<select name="priority">
								<option value="1">1 - The highest priority</option>
<?	for($i=2;$i<10; $i++){?>
								<option value="<?=$i?>" <?=$i==$priority?"selected":""?>><?=$i?></option>
<?	}?>							<option value="10" <?=$priority==10?"selected":""?>>10 - The lowest priority</option>
							</select>
						</td>
					</tr>
			
					<tr valign="top">
						<td class="formItemCaption">Meta Keywords</td>
						<td class="formItemControl">
							<input type="text" name="meta_keywords" value="<?=htmlspecialchars($meta_keywords)?>">
						</td>
					</tr>
					<tr valign="top">
						<td class="formItemCaption">Meta Title</td>
						<td class="formItemControl">
							<input type="text" name="meta_title" value="<?=htmlspecialchars($meta_title)?>">
						</td>
					</tr>
					<tr valign="top">
						<td class="formItemCaption">Page URL (pregenerated)</td>
						<td class="formItemControl">
							<span style="text-decoration:underline;color:blue;"><?=htmlspecialchars($url_default)?></span>
						</td>
					</tr>
					<tr valign="top">
						<td class="formItemCaption">Page URL (custom)</td>
						<td class="formItemControl">
							<input type="text" name="url_custom" maxlength="128" value="<?=htmlspecialchars($url_custom)?>">
						</td>
					</tr>
					<tr valign="top">
						<td class="formItemCaption">Meta Description</td>
						<td class="formItemControl">
							<textarea class="no-mce"  name="meta_description"><?=htmlspecialchars($meta_description)?></textarea>
						</td>
					</tr>
				</table>
				<div class="admin-form-header"><span class="icon ic-icon ic-link"></span>Link Locations</div>
				<table width="100%" cellpadding="0" cellspacing="0" border="0">
					<tr valign="top">
						<td class="formItemCaption">Top</td>
						<td class="formItemControl">
							<select name="place_top" class="short">
							<option value="No">No</option>
							<option value="Yes" <?=preg_match("/Top/i", $options)?"selected":""?>>Yes</option>
							</select>
						</td>
					</tr>
					<tr valign="top">
						<td class="formItemCaption">Bottom</td>
						<td class="formItemControl">
							<select name="place_bottom" class="short">
								<option value="No">No</option>
								<option value="Yes" <?=preg_match("/Bottom/i", $options)?"selected":""?>>Yes</option>
							</select>
						</td>
					</tr>
				</table>
				
				<div class="admin-form-header editor-manager"><span class="icon ic-icon ic-pencil"></span>Page HTML</div>
				<div class="formItemControl big">
					<textarea cols="50" rows="8" id="content" class="no-mce editor-area" name="content"><?=gs($content)?></textarea>
				</div>
			</div>
		</div>
	</div>
	<div class="admin-form-buttons">
		<input type="submit" value="Save changes"/>
		<input type="reset" value="Reset form">
	</div>
</form>
