<?php
	if (!defined("ENV")) exit();

	$adminView = Ddm_AdminView::getInstance();

	require_once("content/classes/class.product_attribute.php");
	$productAttribute = new ProductAttribute($db);
	
	// MANY LINES TO PREPARE PRODUCT DATA :)
	$prev_pid = null;
	$next_pid = null;

	$mode = isset($mode)?trim($mode):"";
	$last_active_tab = isset($last_active_tab)?trim($last_active_tab):"main";

	$do_apply = isset($do_apply) ? trim($do_apply) : "";
	$do_apply = $do_apply == "yes";
	
	$pid = isset($pid)?intval($pid):"";
	$cid = isset($cid)?intval($cid):"0";
	$secondary_categories = isset($secondary_categories)?$secondary_categories:array();
	$product_id  = isset($product_id)?trim($product_id):"";
	$product_sku  = isset($product_sku)?trim($product_sku):"";
	$product_upc  = isset($product_upc)?trim($product_upc):"";
	$estimated_shipping_price =  isset($estimated_shipping_price)?(trim($estimated_shipping_price)!=""?normalizeNumber($estimated_shipping_price)*1:"-1.00000"):"-1.00000";
	$product_gtin  = isset($product_gtin)?trim($product_gtin):"";
	$product_mpn  = isset($product_mpn)?trim($product_mpn):"";
	$old_product_id  = $product_id;
	$title = isset($title)?trim($title):"";
	$meta_keywords = isset($meta_keywords)?trim($meta_keywords):"";
	$meta_title = isset($meta_title)?trim($meta_title):"";
	$meta_description = isset($meta_description)?trim($meta_description):"";
	$url_custom = isset($url_custom)?trim($url_custom):"";

	$manufacturer_id = isset($manufacturer_id)?intval($manufacturer_id):"0";
	$cost = isset($cost)?normalizeNumber($cost)*1:"0.00";
	$price =  isset($price)?normalizeNumber($price)*1:"0.00";
	$price2 =  isset($price2)?normalizeNumber($price2)*1:"0.00";
	$call_for_price = isset($call_for_price)?trim($call_for_price):"No";

	$digital_product = isset($digital_product)?$digital_product:"No";
	$digital_product_file = isset($digital_product_file)?$digital_product_file:"";

	$price_level_1 =  isset($price_level_1)?normalizeNumber($price_level_1)*1:"0.00";
	$price_level_2 =  isset($price_level_2)?normalizeNumber($price_level_2)*1:"0.00";
	$price_level_3 =  isset($price_level_3)?normalizeNumber($price_level_3)*1:"0.00";

	$description = isset($description)?trim($description):"";
	$overview = isset($overview)?trim($overview):"";
	$case_pack = isset($case_pack)?intval(normalizeNumber($case_pack)):-1;
	$inter_pack = isset($inter_pack)?intval(normalizeNumber($inter_pack)):-1;

	$gift_quantity = isset($gift_quantity)?intval(normalizeNumber($gift_quantity)):0;

	$is_locked =  isset($is_locked)?trim($is_locked):"No";
	$is_hotdeal =  isset($is_hotdeal)?trim($is_hotdeal):"No";
	$is_home =  isset($is_home)?trim($is_home):"No";
	$is_visible =  isset($is_visible)?trim($is_visible):"No";
	$is_google_co =  isset($is_google_co)?trim($is_google_co):"No";

	$inventory_control =  isset($inventory_control)?trim($inventory_control):"No";
	$inventory_rule =  isset($inventory_rule)?trim($inventory_rule):"Hide";
	$stock = isset($stock) ? normalizeNumber($stock) *1 : 0;
	$stock = $stock < 0 ? 0 : $stock;
	
	$stock_warning = isset($stock_warning)?$stock_warning*1:0;
	$stock_warning = $stock_warning < 0 ? 0 : $stock_warning;

	$weight = isset($weight)?normalizeNumber($weight)*1:0;
	$free_shipping = isset($free_shipping)?trim($free_shipping):"No";
	//$shipping_price =  isset($shipping_price)?normalizeNumber($shipping_price)*1:"0.00";

	$shipping_price =  isset($shipping_price)?$shipping_price:array();
	$shipping_price = is_array($shipping_price)?$shipping_price:array();

	$min_order = isset($min_order)?$min_order*1:1;
	$min_order = $min_order<1?1:$min_order;
	$max_order = isset($max_order)?$max_order*1:0;

	$dimension_width = isset($dimension_width) ? $dimension_width*1 : 0;
	$dimension_length = isset($dimension_length) ? $dimension_length*1 : 0;
	$dimension_height = isset($dimension_height)? $dimension_height*1 : 0;
	$priority = isset($priority) ? $priority*1 : 0;

	$product_families = isset($product_families)?$product_families:"";
	$product_gifts = isset($product_gifts)?$product_gifts:"";

	$image = isset($image)?$image:"";
	$image_url = isset($image_url) ? trim($image_url) :"";
	
	$zoom_option = isset($zoom_option)?$zoom_option:"global";
	
	$lock_fields = isset($lock_fields)?$lock_fields:array();

	// image alt text
	$image_alt_text = isset($image_alt_text)?$image_alt_text:"";

	//$secondary_image_visible = isset($secondary_image_visible)?trim($secondary_image_visible):"No";
	$may_upload_image = false;
	$generate_url = false;
	$products_location_id = isset($products_location_id) ? intval($products_location_id) : 0;

	$amazon_id =  isset($amazon_id)?trim($amazon_id):"";
	$amazon_id_type =  isset($amazon_id_type)?trim($amazon_id_type):0;
	$amazon_item_condition =  isset($amazon_item_condition)?trim($amazon_item_condition):0;
	$ebay_cat_id =  isset($ebay_cat_id)?trim($ebay_cat_id):0;
	$yahoo_path =  isset($yahoo_path)?trim($yahoo_path):"";
	$google_item_condition =  isset($google_item_condition)?trim($google_item_condition):"";
	$google_availability = isset($google_availability)?trim($google_availability):"";
	$google_online_only = isset($google_online_only)?trim($google_online_only):"";
	$google_gender = isset($google_gender)?trim($google_gender):"";
	$google_age_group = isset($google_age_group)?trim($google_age_group):"";
	$google_color = isset($google_color)?trim($google_color):"";
	$google_size = isset($google_size)?trim($google_size):"";
	$google_material = isset($google_material)?trim($google_material):"";
	$google_pattern = isset($google_pattern)?trim($google_pattern):"";
	$google_product_type =  isset($google_product_type)?trim($google_product_type):"";
	$pricegrabber_category =  isset($pricegrabber_category)?trim($pricegrabber_category):"";
	$pricegrabber_item_condition =  isset($pricegrabber_item_condition)?trim($pricegrabber_item_condition):"";
	$pricegrabber_part_number =  isset($pricegrabber_part_number)?trim($pricegrabber_part_number):"";
	$nextag_part_number =  isset($nextag_part_number)?trim($nextag_part_number):"";
	$nextag_category =  isset($nextag_category)?trim($nextag_category):"";
	$nextag_item_condition =  isset($nextag_item_condition)?trim($nextag_item_condition):"";
	
	$nonce = isset($nonce)?trim($nonce):"";

	$taxService = Tax_ProviderFactory::getTaxService();

	// PREPARE DB MODIFIER
	$db->reset();
	$db->assign("cid", $cid);
	$db->assignStr("is_locked", $is_locked);
	$db->assignStr("is_visible", $is_visible);
	$db->assignStr("is_hotdeal", $is_hotdeal);
	$db->assignStr("is_home", $is_home);
	
	if ($taxService instanceof Tax_CustomProvider)
	{
		$is_taxable =  isset($is_taxable) ? trim($is_taxable) : "No";
		$tax_rate =  isset($tax_rate) ? (trim($tax_rate) != "" ? normalizeNumber($tax_rate)*1 : "-1.00000") : "-1.00000";
		$tax_class_id = $tax_rate >= 0 ? 0 : isset($tax_class_id) ? intval($tax_class_id) : 0;
		
		$db->assignStr("is_taxable", $is_taxable);
		$db->assign("tax_rate", $tax_rate);
		$db->assign("tax_class_id", $tax_class_id);
	}
	elseif ($taxService instanceof Tax_Avalara_AvalaraService)
	{
		$avalara_tax_code = isset($avalara_tax_code) ? $avalara_tax_code : '';

		$db->assignStr("avalara_tax_code",$avalara_tax_code);
	}
	else if ($taxService instanceof Tax_Exactor_ExactorService)
	{
		$exactor_euc_code = isset($exactor_euc_code) ? $exactor_euc_code : '';

		$db->assignStr('exactor_euc_code', $exactor_euc_code);
	}

	$db->assignStr("is_google_co", $is_google_co);

	$db->assign("ebay_cat_id", $ebay_cat_id);
	$db->assignStr("amazon_id", $amazon_id);
	$db->assign("amazon_id_type", $amazon_id_type);
	$db->assign("amazon_item_condition", $amazon_item_condition);
	$db->assignStr("yahoo_path", $yahoo_path);
	$db->assignStr("google_item_condition", $google_item_condition);
	$db->assignStr("google_availability", $google_availability);
	$db->assignStr("google_online_only", $google_online_only);
	$db->assignStr("google_gender", $google_gender);
	$db->assignStr("google_age_group", $google_age_group);
	$db->assignStr("google_color", $google_color);
	$db->assignStr("google_size", $google_size);
	$db->assignStr("google_material", $google_material);
	$db->assignStr("google_pattern", $google_pattern);
	$db->assignStr("google_product_type", $google_product_type);
	$db->assignStr("pricegrabber_category", $pricegrabber_category);
	$db->assignStr("pricegrabber_item_condition", $pricegrabber_item_condition);
	$db->assignStr("pricegrabber_part_number", $pricegrabber_part_number);
	$db->assignStr("nextag_part_number", $nextag_part_number);
	$db->assignStr("nextag_category", $nextag_category);
	$db->assignStr("nextag_item_condition", $nextag_item_condition);

	$db->assignStr("inventory_control", $inventory_control);
	$db->assignStr("inventory_rule", $inventory_rule);
	$db->assign("stock", $stock);
	$db->assign("stock_warning", $stock_warning);
	$db->assign("priority", $priority);
	$db->assign("weight", $weight);
	$db->assignStr("free_shipping", $free_shipping);

	$digital_product_error = false;
	$upload_product_file = false;
	
	if ($digital_product == "Yes")
	{
		// check for uploaded file first
		if(isset($_FILES["digital_product_file_upload"]["tmp_name"]) && $_FILES["digital_product_file_upload"]["tmp_name"] != '' && is_uploaded_file($_FILES["digital_product_file_upload"]["tmp_name"]))
		{
			$digital_product_file = $_FILES["digital_product_file_upload"]["name"];
			$upload_product_file = true;
		}
		// then check is name provided (entered OR from previously uplaoded file)
		else if ($digital_product_file != "")
		{
			if (file_exists("./content/download/".$digital_product_file) && is_file("./content/download/".$digital_product_file))
			{
				$digital_product_error = false;
			}
			else
			{
				$digital_product_error = true;
				$db->assignStr("is_visible", "No");
				$is_visible = "No";
			}
		}
		//or we have error
		else
		{
			$digital_product_error = true;
			$db->assignStr("is_visible", "No");
			$is_visible = "No";
		}
		$db->assignStr("free_shipping", "Yes");
	}
	else
	{
		if ($weight <= 0)
		{
			Admin_Flash::setMessage('Please note: shippable product is entered without weight', Admin_Flash::TYPE_INFO);
		}
	}
	
	$db->assignStr("digital_product", $digital_product);
	$db->assignStr("digital_product_file", $digital_product_file);
	$db->assign("cost", $cost);
	$db->assign("price", $price2>0?$price2:$price);
	$db->assign("price2", $price2>0?$price:$price2);

	$db->assignStr("call_for_price", $call_for_price);

	if ($settings["WholesaleDiscountType"] == "PRODUCT")
	{
		$db->assign("price_level_1", $price_level_1);
		if ($settings["WholesaleMaxLevels"]>1)
		{
			$db->assign("price_level_2", $price_level_2);
			if ($settings["WholesaleMaxLevels"] > 2)
			{
				$db->assign("price_level_3", $price_level_3);
			}
		}
	}

	$db->assign("min_order", $min_order);
	$db->assign("max_order", $max_order);

	if ($mode == "insert")
	{
		$db->assign("added", "NOW()");
	}

	$db->assignStr("product_id", $product_id);
	$db->assignStr("product_sku", $product_sku);
	$db->assignStr("product_upc", $product_upc);
	$db->assignStr("estimated_shipping_price", $estimated_shipping_price);
	$db->assignStr("product_gtin", $product_gtin);
	$db->assignStr("product_mpn", $product_mpn);

	$db->assign("case_pack", $case_pack);
	$db->assign("inter_pack", $inter_pack);

	$db->assign("gift_quantity", $gift_quantity);

	$db->assign("dimension_width", $dimension_width);
	$db->assign("dimension_length", $dimension_length);
	$db->assign("dimension_height", $dimension_height);

	$db->assignStr("title", $title);
	$db->assignStr("meta_keywords", $meta_keywords);
	$db->assignStr("meta_title", $meta_title);
	$db->assignStr("meta_description", $meta_description);
	$db->assignStr("url_custom", $url_custom);

	if ($settings["CatalogManufacturers"] == "YES")
	{
		$db->assignStr("manufacturer_id", $manufacturer_id);
	}

	$db->assignStr("description", $description);
	$db->assignStr("overview", $overview);
	$db->assignStr("zoom_option", $zoom_option);
	$db->assignStr("lock_fields", implode(",", $lock_fields));

	// image alt text
	$db->assignStr("image_alt_text", $image_alt_text);
	
	$db->assignStr("image_location", $image_url != "" ? "Web" : "Local");
	$db->assignStr("image_url", $image_url);

	$db->assignStr("products_location_id", $products_location_id);
	$duplicate_product_id = false;
	
	$nonce_valid = verify_nonce($nonce, 'product_'.$mode);
	if (!$nonce_valid)
	{
		invalid_nonce_message();
		exit;
	}
	
	switch($mode)
	{
		/**
		 * Add a new product
		 */
		case "insert" : 
		{
			//check is there product with specified ID
			$db->query("SELECT * FROM ".DB_PREFIX."products WHERE product_id LIKE '".$db->escape($product_id)."'");
			if ($db->moveNext())
			{
				$duplicate_product_id = true;
				$product_id = substr(md5(uniqid(rand(), 1)), rand(0, 10), 16);
				$db->assignStr("product_id", $product_id);
			}

			if (!DEMO_LOCK)
			{
				//Insert Product
				$pid = $db->insert(DB_PREFIX."products");
				$may_upload_image = true;
				$generate_url = true;
				
				$adminView->assign('PageHeader', array('Product Added', '', 'icb-product'));
				
				$adminView->assign('PageNote', array(
					array("class"=>"ic-info", "text"=>"<b>New product has been successfully added.</b>", "url"=>"", "visible"=>true),
					array("class"=>"ic-warning", "text"=>"<font color=\"#dd0000\"><b>Duplicate Product ID - the product you entered contained a Product ID (".gs($old_product_id).") already found in the database. The product was assigned a new Product ID (".$product_id."). To change it, please click on the link below.</b></font>", "url"=>"", "visible"=>$duplicate_product_id),
					array("class"=>"ic-warning", "text"=>"<font color=\"#dd0000\"><b>Can't find file ".$digital_product_file." - the product file you entered does not exists or file was not uploaded correctly. Now product is not available for sale</b></font>", "url"=>"", "visible"=>$digital_product_error)
				));
				
				$adminView->assign('PageWhat', array(
					array("text"=>"Edit previous product", "url"=>"admin.php?p=product&mode=update&pid=".$pid."&last_active_tab=".$last_active_tab),
					array("text"=>"Add a new product", "url"=>"admin.php?p=product&mode=insert&cid=".$cid),
					array("text"=>"Browse all products", "url"=>"admin.php?p=products")
				));
				
				$prev_pid = DataAccess_ProductsRepository::getPreviousProductId($db, $pid);
				$next_pid = null; // there can't be next product
			}
			else
			{
				$adminView->assign('PageHeader', array('Product Added', '', 'icb-product'));
				
				$adminView->assign('PageNote', array(
					array("class"=>"ic-info", "text"=>"<b>New product has been successfully added</b>", "url"=>"", "visible"=>true),
					array("class"=>"ic-warning", "text"=>"<font color=\"#dd0000\"><b>Duplicate Product ID - the product you entered contained a Product ID (".gs($old_product_id).") already found in the database. The product was assigned a New Product ID (".$product_id."). To change it, please go to edit product.</b></font>", "url"=>"", "visible"=>$duplicate_product_id),
					array("class"=>"ic-warning", "text"=>"<font color=\"#dd0000\"><b>Can't find file ".$digital_product_file." - the product file you entered does not exists or file was not uploaded correctly. Now product is not available for sale</b></font>", "url"=>"", "visible"=>$digital_product_error)
				));
				
				$adminView->assign('PageWhat', array(
					array("text"=>"Add a New Product Again", "url"=>"admin.php?p=product&mode=insert&cid=".$cid),
					array("text"=>"Browse Products", "url"=>"admin.php?p=products")
				));
			}
			
			break;
		}
		
		/**
		 * Update product
		 */
		case "update" : 
		{
			require_once("content/engine/engine_url_".($settings["USE_MOD_REWRITE"]=="YES" ? "rewrite" : "default").".php");

			//check product id
			$db->query("SELECT * FROM ".DB_PREFIX."products WHERE product_id LIKE '".$db->escape($product_id)."' AND pid<>'".intval($pid)."'");
			if ($db->moveNext())
			{
				//product id already exists
				$duplicate_product_id = true;
				$product_id = substr(md5(uniqid(rand(), 1)), rand(0, 24), 20);
				$db->assignStr("product_id", $product_id);
			}
			//good, update product
			$db->query("SELECT * FROM ".DB_PREFIX."products WHERE pid='".intval($pid)."'");
			$db->moveNext();
			$current_product_id = $db->col["product_id"];
			
			if (!DEMO_LOCK)
			{
				$db->update(DB_PREFIX."products", "WHERE pid='".intval($pid)."'");
				$db->query("
					UPDATE ".DB_PREFIX."orders_content
					SET product_id = '".$db->escape($product_id)."',
						title =  '".$db->escape($title)."'
					WHERE
						pid='".$pid."'
				");
			}
			
			//rename existing image
			$c_image = ProductHasImage($current_product_id);
			
			if ($c_image && (strtolower($current_product_id) != strtolower($product_id)))
			{
				$image_ext = getFileExt($c_image);
				
				//rename image file
				if (!DEMO_LOCK)
				{
					@copy($c_image, $product_images_dir."/".imageFileName($product_id).".".$image_ext);
					@chmod($product_images_dir."/".imageFileName($product_id).".".$image_ext, getFilePermissionMode());
					
					@unlink($c_image);

					$thumb = ProductHasThumb2($current_product_id);
					if ($thumb)
					{
						@copy($thumb, $product_thumbs2_dir."/".imageFileName($product_id).".".$image_ext);
						@chmod($product_thumbs2_dir."/".imageFileName($product_id).".".$image_ext, getFilePermissionMode());
						@unlink($thumb);
					}

					//rename thumb
					$thumb = ProductHasThumb($current_product_id);
					if ($thumb)
					{
						@copy($thumb, $product_thumbs_dir."/".imageFileName($product_id).".".$image_ext);
						@chmod($product_thumbs_dir."/".imageFileName($product_id).".".$image_ext, getFilePermissionMode());
						@unlink($thumb);
					}
				}
			}
			
			//rename secondary images
			if ($current_product_id != $product_id)
			{
				$db->query("SELECT * FROM ".DB_PREFIX."products_images WHERE pid='".$pid."'");
				$secondaryImages = array();
				
				while ($db->movenext())
				{
					$imageNum = substr($db->col["filename"], strrpos($db->col["filename"], "-"), 10);
					$secondaryImages[$db->col["iid"]] = $db->col;
					$secondaryImages[$db->col["iid"]]["newfilename"] = imageFileName($product_id)."-".$imageNum;
				}
				
				foreach ($secondaryImages as $iid => $secondaryImage)
				{
					$db->query("UPDATE ".DB_PREFIX."products_images SET filename='".$db->escape($secondaryImage["newfilename"])."' WHERE iid='".$iid."'");
					$old_secondary_image = $product_secondary_images_dir."/".$secondaryImage["filename"].".".$secondaryImage["type"];
					$new_secondary_image = $product_secondary_images_dir."/".$secondaryImage["newfilename"].".".$secondaryImage["type"];
					@copy($old_secondary_image, $new_secondary_image);
					@chmod($new_secondary_image, getFilePermissionMode());
					@unlink($old_secondary_image);
					
					$old_secondary_image_thumb = $product_secondary_images_dir."/thumbs/".$secondaryImage["filename"].".jpg";
					$new_secondary_image_thumb = $product_secondary_images_dir."/thumbs/".$secondaryImage["newfilename"].".jpg";
					@copy($old_secondary_image_thumb, $new_secondary_image_thumb);
					@chmod($new_secondary_image_thumb, getFilePermissionMode());
					@unlink($old_secondary_image_thumb);
				}
			}
			
			$may_upload_image = true;
			$generate_url = true;

			$adminView->assign('PageHeader', array('Product Updated', '', 'icb-product'));
			
			$adminView->assign('PageNote', array(
				array("class"=>"ic-info", "text"=>"<b>Product has been successfully updated</b>", "url"=>"", "visible"=>true),
				array("class"=>"ic-warning", "text"=>"<font color=\"#dd0000\"><b>Duplicate Product ID - the product you entered contained a Product ID (".gs($old_product_id).") already found in the database. The product was assigned a New Product ID (".$product_id."). To change it, please go to edit product.</b></font>", "url"=>"", "visible"=>$duplicate_product_id),
					array("class"=>"ic-warning", "text"=>"<font color=\"#dd0000\"><b>Can't find file ".$digital_product_file." - the product file you entered does not exists or file was not uploaded correctly. Now product is not available for sale</b></font>", "url"=>"", "visible"=>$digital_product_error)
			));
			
			$adminView->assign('PageWhat', array(
				array("text"=>"<a target=_blank href=\"index.php?p=product&id=".$pid."\">View Edited Product</a> (note: product must be available for sale)", "url"=>"", "visible"=>$is_visible == "Yes"),
				array("text"=>"Back to Product Editing", "url"=>"admin.php?p=product&mode=update&pid=".$pid."&last_active_tab=".$last_active_tab),
				array("text"=>"Add a New Product", "url"=>"admin.php?p=product&mode=insert&cid=".$cid),
				array("text"=>"Browse Products", "url"=>"admin.php?p=products")
			));
			
			$db->query("SELECT MAX(pid) AS c FROM ".DB_PREFIX."products WHERE pid<'".intval($pid)."'");
			$db->moveNext();
			
			$prev_pid = DataAccess_ProductsRepository::getPreviousProductId($db, $pid);
			$next_pid = DataAccess_ProductsRepository::getNextProductId($db, $pid);
			
			break;
		}
		
		/**
		 * Delete product
		 */
		case "delete" : 
		{
			$product_deleted = Admin_ProductProcess::deleteProduct($pid, $db, $product_images_dir, $product_thumbs_dir, $product_thumbs2_dir, $product_secondary_images_dir);
			if ($product_deleted)
			{
				$adminView->assign('PageHeader', array('Product Removed', '', 'icb-product'));
				
				$adminView->assign('PageNote', array(
					array("class"=>"ic-info", "text"=>"<b>Product has been successfully removed</b>", "url"=>"", "visible"=>true)
				));
				
				$adminView->assign('PageWhat', array(
					array("text"=>"Browse products", "url"=>"admin.php?p=products"),
					array("text"=>"Add new product", "url"=>"admin.php?p=product&mode=insert")
				));

				$prev_pid = DataAccess_ProductsRepository::getPreviousProductId($db, $pid);
				$next_pid = DataAccess_ProductsRepository::getNextProductId($db, $pid);
			}
			break;
		}
		
		/**
		 * Delete many products
		 */
		case "bulkDelete": 
		{
			$products_deleted = true;
			
			if (isset($_REQUEST['pids']))
			{
				$products_deleted = Admin_ProductProcess::bulkDeleteProducts($_REQUEST['pids'], $db, $product_images_dir, $product_thumbs_dir, $product_thumbs2_dir, $product_secondary_images_dir);
			}
			
			if ($products_deleted)
			{
				$adminView->assign('PageHeader', array('Product Removed', '', 'icb-product'));
				
				$adminView->assign('PageNote', array(
					array("class"=>"ic-info", "text"=>"<b>Products have been successfully removed</b>", "url"=>"", "visible"=>true)
				));
				
				$adminView->assign('PageWhat', array(
					array("text"=>"Browse products", "url"=>"admin.php?p=products"),
					array("text"=>"Add new product", "url"=>"admin.php?p=product&mode=insert")
				));
			}
			break;
		}
		
		/**
		 * Delete product attribute
		 */
		case "delete_attribute" : 
		{
			if (!DEMO_LOCK)
			{
				$product_attribute_id = isset($_REQUEST["paid"]) ? intval($_REQUEST["paid"]) : false;

				if ($product_attribute_id)
				{
					$productAttribute->delete($pid, $product_attribute_id);
				}
			}
			
			$adminView->assign('PageHeader', array('Attribute Removed', '', 'icb-product'));
			
			$adminView->assign('PageNote', array(
				array("class"=>"ic-info", "text"=>"<b>Product attribute has been successfully removed</b>", "url"=>"",  "visible"=>true)
			));
			
			$adminView->assign('PageWhat', array(
				array("text"=>"Back to product editing", "url"=>"admin.php?p=product&mode=update&pid=".$pid."&last_active_tab=".$last_active_tab),
				array("text"=>"Add new product", "url"=>"admin.php?p=product&mode=insert"),
				array("text"=>"Browse products", "url"=>"admin.php?p=products")
			));
			
			$do_apply = "yes";
			
			break;
		}
		
		/**
		 * Delete inventory record
		 */
		case "delete_inv_record" : 
		{
			$pi_id = isset($pi_id)?$pi_id*1:0;

			if (!DEMO_LOCK)
			{
				$db->query("DELETE FROM ".DB_PREFIX."products_inventory WHERE pid='".intval($pid)."' AND pi_id='".intval($pi_id)."'");
			}
			
			$adminView->assign('PageHeader', array('Inventory Record Removed', '', 'icb-product'));
			
			$adminView->assign('PageNote', array(
				array("class"=>"ic-info", "text"=>"<b>Product inventory record has been successfully removed</b>", "url"=>"",  "visible"=>true)
			));
			
			$adminView->assign('PageWhat', array(
				array("text"=>"Back to product editing", "url"=>"admin.php?p=product&mode=update&pid=".intval($pid)."&last_active_tab=".$last_active_tab),
				array("text"=>"Add new product", "url"=>"admin.php?p=product&mode=insert"),
				array("text"=>"Browse products", "url"=>"admin.php?p=products")
			));
			
			$do_apply = "yes";
			
			break;
		}
		
		/**
		 * Delete quantity discout
		 */
		case "delete_discount" : 
		{
			$qd_id = isset($qd_id) ? $qd_id * 1 : 0;
			
			if (!DEMO_LOCK)
			{
				$db->query("DELETE FROM ".DB_PREFIX."products_quantity_discounts WHERE pid='".intval($pid)."' AND qd_id='".$qd_id."'");
			}
			
			$adminView->assign('PageHeader', array('Quantity Discount Removed', '', 'icb-product'));
			
			$adminView->assign('PageNote', array(
				array("class"=>"ic-info", "text"=>"<b>Quantity Discount has been successfully removed</b>", "url"=>"",  "visible"=>true)
			));
			
			$adminView->assign('PageWhat', array(
				array("text"=>"Back to product editing", "url"=>"admin.php?p=product&mode=update&pid=".intval($pid)."&last_active_tab=".$last_active_tab),
				array("text"=>"Add new product", "url"=>"admin.php?p=product&mode=insert"),
				array("text"=>"Browse products", "url"=>"admin.php?p=products")
			));
			$do_apply = "yes";
			break;
		}
		
		/**
		 * Delete product image
		 */
		case "delete_image" : 
		{
			if (!DEMO_LOCK)
			{
				$db->query("SELECT product_id FROM ".DB_PREFIX."products WHERE pid='".intval($pid)."'");
				if ($db->moveNext())
				{
					$product_id = $db->col["product_id"];

					if (isset($delete_image) && $delete_image == "true")
					{
						$img_file = ProductHasImage($product_id);
						if ($img_file) unlink($img_file);
					}

					if (isset($delete_thumb) && $delete_thumb == "true")
					{
						$thumb_file = ProductHasThumb($product_id);
						if ($thumb_file) @unlink($thumb_file);
					}

					if (isset($delete_thumb2) && $delete_thumb2 == "true")
					{
						$thumb2_file = ProductHasThumb2($product_id);
						if ($thumb2_file) @unlink($thumb2_file);
					}

					$do_apply = "yes";

				}
			}
			$adminView->assign('PageHeader', array('Image Removed', '', 'icb-product'));
			$adminView->assign('PageNote', array(
				array("class"=>"ic-info", "text"=>"<b>Product image has been successfully removed</b>", "url"=>"",  "visible"=>true)
			));
			break;
		}
		
		/**
		 * Delete secondary image
		 */
		case "delete_secondary_image" :
		{
			$adminView->assign('PageHeader', array('Delete Product Image', '', ''));
			$secondary_id = isset($secondary_id)?intval($secondary_id):0;
			$db->query("SELECT * FROM ".DB_PREFIX."products_images WHERE iid='".$secondary_id."'");
			
			if ($db->moveNext())
			{
				if (!DEMO_LOCK)
				{
					@unlink($product_secondary_images_dir."/".$db->col["filename"].".".$db->col["type"]);
					@unlink($product_secondary_images_dir."/thumbs/".$db->col["filename"].".jpg");
					$db->query("DELETE FROM ".DB_PREFIX."products_images WHERE iid='".$secondary_id."'");
				}
				$adminView->assign('PageNote', array(
					array("class"=>"ic-info", "text"=>"<b>Image has been successfully removed</b>", "url"=>"", "visible"=>true)
				));
			}
			else
			{
				$adminView->assign('PageNote', array(
					array("class"=>"ic-cross", "text"=>"<b>Can't select image by ID</b>", "url"=>"", "visible"=>true)
				));
			}
			
			$adminView->assign('PageWhat', array(
				array("text"=>"Back to product editing", "url"=>"admin.php?p=product&mode=update&pid=".$pid."&last_active_tab=".$last_active_tab),
				array("text"=>"Add new product", "url"=>"admin.php?p=product&mode=insert&cid=".$cid),
				array("text"=>"Browse products", "url"=>"admin.php?p=products")
			));
			
			break;
		}
		
		/**
		 * Incorrect action
		 */
		default :
		{
			$adminView->assign('PageHeader', array('Incorrect Action', '', 'icb-product'));
			$adminView->assign('PageWhat', array(
				array("text"=>"Browse products", "url"=>"admin.php?p=products"),
				array("text"=>"Add new product", "url"=>"admin.php?p=product&mode=insert")
			));
		}
	}

	/**
	 * Update product URL
	 */
	if (!DEMO_LOCK && $generate_url)
	{
		//render URL, 
		$db->query("UPDATE ".DB_PREFIX."products SET url_default='".$db->escape($settings["SearchURLProductTemplate"])."' WHERE pid='".intval($pid)."'");
		$query = setProductUrlSQL($settings["SearchAutoGenerateLowercase"] == "YES", $settings["SearchURLJoiner"], "p.pid='".intval($pid)."'");
		$db->query($query);
		if ($settings["SearchAutoGenerateLowercase"] == "YES")
		{
			$db->query("UPDATE ".DB_PREFIX."products SET url_default=LOWER(url_default) WHERE pid='".intval($pid)."'");
		}
		//update hash
		$db->query("UPDATE ".DB_PREFIX."products SET url_hash=MD5(IF(url_custom='', url_default, url_custom)) WHERE pid='".intval($pid)."'");
	}

	/**
	 * Upload product image
	 */
	if (!DEMO_LOCK && in_array($mode, array("insert", "update")) && $may_upload_image && !empty($_FILES["image"]["tmp_name"]))
	{
		$image_data = @getImageSize($_FILES["image"]["tmp_name"]);
		//check is this image correct
		if (in_array($image_data[2], $imageTypes))
		{
			$imgFileName = imageFileName($product_id);
			$destination = $product_images_dir."/".$imgFileName.".";

			//remove existing image & thumbs
			@unlink($product_images_dir."/".$imgFileName.".jpg");
			@unlink($product_images_dir."/".$imgFileName.".png");
			@unlink($product_images_dir."/".$imgFileName.".gif");
			@unlink($product_thumbs_dir."/".$imgFileName.".jpg");
			@unlink($product_thumbs_dir."/".$imgFileName.".png");
			@unlink($product_thumbs_dir."/".$imgFileName.".gif");
			@unlink($product_thumbs2_dir."/".$imgFileName.".jpg");
			@unlink($product_thumbs2_dir."/".$imgFileName.".png");
			@unlink($product_thumbs2_dir."/".$imgFileName.".gif");
			//add new file extension

			$extension = '';
			switch ($image_data[2])
			{
				case IMAGETYPE_GIF: $extension.="gif"; break;
				case IMAGETYPE_JPEG: $extension.="jpg"; break;
				case IMAGETYPE_PNG: $extension.="png"; break;
			}
			$destination .= $extension;
			
			if (@copy($_FILES["image"]["tmp_name"], $destination))
			{
				chmod($destination, getFilePermissionMode());
				//in case of JPG and PNG image generate thumb
				if ($settings["CatalogThumbType"] != "Manual" && in_array($image_data[2], array(IMAGETYPE_JPEG, IMAGETYPE_PNG, IMAGETYPE_GIF)))
				{
					generateProductThumb($destination, $product_thumbs_dir."/".$imgFileName.".{$extension}");
				}

				if ($settings["CatalogThumb2Type"] != "Manual" && in_array($image_data[2], array(IMAGETYPE_JPEG, IMAGETYPE_PNG, IMAGETYPE_GIF)))
				{
					generateProductPreview($destination, $product_thumbs2_dir."/".$imgFileName.".{$extension}");
				}

				$db->query("UPDATE ".DB_PREFIX."products SET image_url='', image_location='Local' WHERE pid='".$pid."'");
			}
			else
			{
				$adminView->assign('PageNote', array(
					array("class"=>"ic-cross", "text"=>"<b>Can't upload product image. Please check free disk space and permissions</b>", "url"=>"",  "visible"=>true)
				));
			}
		}
		else
		{
			$adminView->assign('PageNote', array(
				array("class"=>"ic-cross", "text"=>"<b>Can't upload product image. Incorrect image type: ".$_FILES["image"]["type"]."</b>", "url"=>"",  "visible"=>true)
			));
		}
	}

	if (($settings["CatalogThumbType"] == "Manual") && !DEMO_LOCK && in_array($mode, array("insert", "update")) && $may_upload_image && !empty($_FILES["image_thumb"]["tmp_name"]))
	{
		$image_data = @getImageSize($_FILES["image_thumb"]["tmp_name"]);
		//check is this image correct
		if (in_array($image_data[2], $imageTypes))
		{
			$destination = $product_thumbs_dir."/".imageFileName($product_id).".";
			//remove existing image & thumbs
			@unlink($destination."jpg");
			@unlink($destination."png");
			@unlink($destination."gif");
			//add new file extension
			$extension = '';
			
			switch ($image_data[2])
			{
				case IMAGETYPE_GIF: $extension.="gif"; break;
				case IMAGETYPE_JPEG: $extension.="jpg"; break;
				case IMAGETYPE_PNG: $extension.="png"; break;
			}
			
			$destination .= $extension;
			
			if (@copy($_FILES["image_thumb"]["tmp_name"], $destination))
			{
				chmod($destination, getFilePermissionMode());
				$db->query("UPDATE ".DB_PREFIX."products SET image_url='', image_location='Local' WHERE pid='".$pid."'");
			}
			else
			{
				$adminView->assign('PageNote', array(
					array("class"=>"ic-cross", "text"=>"<b>Can't upload product thumbnail image. Please check free disk space and permissions</b>", "url"=>"",  "visible"=>true)
				));
			}
		}
		else{
			$adminView->assign('PageNote', array(
				array("class"=>"ic-cross", "text"=>"<b>Can't upload product thumbnail image. Incorrect image type: ".$_FILES["image"]["type"]."</b>", "url"=>"",  "visible"=>true)
			));
		}
	}

	if (($settings["CatalogThumb2Type"] == "Manual") && !DEMO_LOCK && in_array($mode, array("insert", "update")) && $may_upload_image && !empty($_FILES["image_thumb2"]["tmp_name"]))
	{
		$image_data = @getImageSize($_FILES["image_thumb2"]["tmp_name"]);
		//check is this image correct
		if (in_array($image_data[2], $imageTypes))
		{
			$destination = $product_thumbs2_dir."/".imageFileName($product_id).".";
			//remove existing image & thumbs
			@unlink($destination."jpg");
			@unlink($destination."png");
			@unlink($destination."gif");
			//add new file extension
			$extension = '';
			
			switch ($image_data[2])
			{
				case IMAGETYPE_GIF: $extension.="gif"; break;
				case IMAGETYPE_JPEG: $extension.="jpg"; break;
				case IMAGETYPE_PNG: $extension.="png"; break;
			}
			
			$destination .= $extension;
			
			if (@copy($_FILES["image_thumb2"]["tmp_name"], $destination))
			{
				chmod($destination, getFilePermissionMode());
				$db->query("UPDATE ".DB_PREFIX."products SET image_url='', image_location='Local' WHERE pid='".$pid."'");
			}
			else
			{
				$adminView->assign('PageNote', array(
					array("class"=>"ic-cross", "text"=>"<b>Can't upload product image for product page. Please check free disk space and permissions</b>", "url"=>"",  "visible"=>true)
				));
			}
		}
		else
		{
			$adminView->assign('PageNote', array(
				array("class"=>"ic-cross", "text"=>"<b>Can't upload product image for product page. Incorrect image type: ".$_FILES["image"]["type"]."</b>", "url"=>"",  "visible"=>true)
			));
		}
	}

	/**
	 * Secondary images
	 */
	if (!DEMO_LOCK && in_array($mode, array("insert", "update")))
	{
		$imgFileName = imageFileName($product_id);
		
		// update secondary images
		$is_secondary_visible = isset($is_secondary_visible)?$is_secondary_visible:array();
		$is_secondary_visible = is_array($is_secondary_visible)?$is_secondary_visible:array();

		$secondary_image_priority = isset($secondary_image_priority)?$secondary_image_priority:array();
		$secondary_image_priority = is_array($secondary_image_priority)?$secondary_image_priority:array();
		
		// alt text
		$alt_text = (isset($alt_text) && is_array($alt_text)) ? $alt_text : array();

		$db->query("UPDATE ".DB_PREFIX."products_images SET is_visible='No' WHERE pid='".$pid."'");
		foreach ($is_secondary_visible as $iid=>$v)
		{
			$db->reset();
			$db->assignStr("is_visible", "Yes");
			$db->assignStr("image_priority", $secondary_image_priority[$iid]);
			$db->assignStr("alt_text", strip_tags($alt_text[$iid]));
			$db->update(DB_PREFIX."products_images", "WHERE pid='".$pid."' AND iid='".$iid."'");
		}
		
		// secondary images
		for ($i=1; $i<=3; $i++)
		{
			if (in_array($mode, array("insert", "update")) && $may_upload_image && !empty($_FILES["secondary_image_".$i]["tmp_name"]))
			{
				$image_data = @getImageSize($_FILES["secondary_image_".$i]["tmp_name"]);
				//check is this image correct
				if (in_array($image_data[2], $imageTypes))
				{
					//get image extension
					switch ($image_data[2])
					{
						case IMAGETYPE_GIF: $extension = "gif"; break;
						case IMAGETYPE_JPEG: $extension = "jpg"; break;
						case IMAGETYPE_PNG: $extension = "png"; break;
					}
					$siv = "secondary_image_visible_".$i;
					$secondary_image_visible = isset($$siv) ? "Yes" : "No";
					
					// image alt text
					$alt_text_field = "secondary_image_alt_text_".$i;
					$alt_text = isset($$alt_text_field) ? $$alt_text_field : '';
					
					//search for next free number
					$db->query("SELECT filename FROM ".DB_PREFIX."products_images WHERE pid='".intval($pid)."'");
					
					while ($db->movenext()) $imagesNames[$db->col["filename"]] = true;
					
					for ($imageNum=1; $imageNum<=10000; $imageNum++)
					{
						if (!isset($imagesNames[$imgFileName."-".$imageNum])) break;
					}
				
					$imagesNames[$imgFileName."-".$imageNum] = true;
					
					//insert image data into database
					$db->reset();
					$db->assignStr("pid", $pid);
					$db->assignStr("is_visible", $secondary_image_visible);
					$db->assignStr("width", $image_data[0]);
					$db->assignStr("height", $image_data[1]);
					$db->assignStr("type", $extension);
					$db->assignStr("filename", $imgFileName."-".$imageNum);
					$db->assignStr("caption", $alt_text);
					$db->assignStr("alt_text", $alt_text);
					$secondary_image_id = $db->insert(DB_PREFIX."products_images");

					$destination = $product_secondary_images_dir."/".$imgFileName."-".$imageNum.".".$extension;

					if (@copy($_FILES["secondary_image_".$i]["tmp_name"], $destination))
					{
						chmod($destination, getFilePermissionMode());
						//in case of JPG and PNG image generate thumb
						if (in_array($image_data[2], array(IMAGETYPE_JPEG, IMAGETYPE_PNG, IMAGETYPE_GIF)))
						{
							generateProductSecondaryThumb($destination, $product_secondary_images_dir."/thumbs/".$imgFileName."-".$imageNum.".jpg");
						}
					}
					else
					{
						$adminView->assign('PageNote', array(
							array("class"=>"ic-cross", "text"=>"<b>Can't upload secondary product image #".$i.". Please check free disk space and permissions</b>", "url"=>"",  "visible"=>true)
						));
					}
				}
				else
				{
					$adminView->assign('PageNote', array(
						array("class"=>"ic-cross", "text"=>"<b>Can't upload secondary product image #".$i.". Incorrect image type: ".$_FILES["secondary_image_".$i]["type"]."</b>", "url"=>"",  "visible"=>true)
					));
				}
			}
		}
	}

	/**
	 * UPDATE SHIPPING PRICE AT PRODUCT LEVEL
	 */
	if (!DEMO_LOCK && in_array($mode, array("insert", "update")))
	{
		$db->query("DELETE FROM ".DB_PREFIX."products_shipping_price WHERE pid='".intval($pid)."'");
		foreach ($shipping_price as $key=>$value)
		{
			$db->reset();
			$db->assignStr("pid", $pid);
			$db->assignStr("ssid", $key);
			$db->assignStr("is_price", trim($value) == "" ? "No" : "Yes");
			$db->assignStr("price", trim($value) != "" ? normalizeNumber($value) : "0.00000");
			$db->insert(DB_PREFIX."products_shipping_price");
		}
	}

	/**
	 * Upload product file
	 */
	if (!DEMO_LOCK && $upload_product_file)
	{
		$_digital_product_file = 'content/download/'.$digital_product_file;
		if (is_file($_digital_product_file)) unlink($_digital_product_file);
		move_uploaded_file($_FILES["digital_product_file_upload"]["tmp_name"], $_digital_product_file);
		chmod($_digital_product_file, getFilePermissionMode());
	}
	
	/**
	 * UPDATE ATTRIBUTES, PRODUCT FAMILIES & GIFT PRODUCTS
	 */
	if (!DEMO_LOCK && in_array($mode, array("insert", "update")))
	{
		/**
		 * Process attributes
		 */
		if ($mode == "update")
		{
			// update existing attributes
			$product_attributes = isset($_REQUEST["product_attributes"]) ? is_array($_REQUEST["product_attributes"]) ? $_REQUEST["product_attributes"] : array() : array(); 
			
			if (count($product_attributes) > 0)
			{
				foreach ($product_attributes as $product_attribute_id => $product_attribute)
				{
					$productAttribute->update($pid, $product_attribute_id, $product_attribute);
				}
			}
			
			// add a new attribute
			$new_attribute = isset($_REQUEST["new_attribute"]) ? is_array($_REQUEST["new_attribute"]) ? $_REQUEST["new_attribute"] : array() : array();
			
			if ($new_attribute && isset($new_attribute["name"]) && trim($new_attribute["name"]) != "")
			{
				$productAttribute->add($pid, $new_attribute);
			}
		}
		
		// assign global attributes
		$global_attributes = isset($_REQUEST["global_attributes"]) ? is_array($_REQUEST["global_attributes"]) ? $_REQUEST["global_attributes"] : array() : array(); 
		if (count($global_attributes) > 0)
		{
			$where_already_assigned = "";
			$where_categories = "";
			
			// select already assigned attributes
			if ($mode == "update")
			{
				$db->query("SELECT * FROM ".DB_PREFIX."products_attributes WHERE pid='".intval($pid)."' AND gaid > 0");
				while ($db->moveNext())
				{
					$where_already_assigned.= ($where_already_assigned == "" ? " " : " AND ")." gaid <> ".$db->col["gaid"];
				}
				
				//select category-specific attributes
				$db->query("SELECT * FROM ".DB_PREFIX."catalog_attributes WHERE cid = '".intval($cid)."'");
				
				while ($db->moveNext())
				{
					$where_categories.= ($where_categories == "" ? "" : " OR ")." gaid = '".intval($db->col["gaid"])."'";
				}
			}

			if ($where_categories != "")
			{
				$sql = "SELECT * FROM ".DB_PREFIX."global_attributes WHERE ((is_global='Yes') OR (".$where_categories.")) ";
			}
			else
			{
				$sql = "SELECT * FROM ".DB_PREFIX."global_attributes WHERE (is_global='Yes') ";
			}
			
			$sql.= ($where_already_assigned != "") ? " AND (".$where_already_assigned.")" : "";
			
			$db->query($sql);

			$selected_attributes = $db->getRecords();

			foreach ($selected_attributes as $selected_attribute)
			{
				if (array_key_exists($selected_attribute["gaid"], $global_attributes))
				{
					$productAttribute->add($pid, $selected_attribute);
				}
			}
		}
		
		/**
		 * Process categories
		 */
		if ($mode == "update")
		{
			$db->query("DELETE FROM ".DB_PREFIX."products_categories WHERE pid='".intval($pid)."'");
		}
		
		for ($i = 0; $i < count($secondary_categories); $i++)
		{
			if ($secondary_categories[$i] != $cid)
			{
				$db->query("INSERT INTO ".DB_PREFIX."products_categories(pid,cid,is_primary) VALUES ('".intval($pid)."','".$secondary_categories[$i]."',0)");
			}
		}
		
		$db->query("INSERT INTO ".DB_PREFIX."products_categories(pid,cid,is_primary) VALUES ('".intval($pid)."','".intval($cid)."',1)");
		
		/**
		 * QUANTITY DISCOUNTS
		 */
		$qdnew_active = isset($qdnew_active)?"Yes":"No";
		$qdnew_min = isset($qdnew_min)?intval($qdnew_min):0;
		$qdnew_max = isset($qdnew_max)?intval($qdnew_max):0;
		$qdnew_discount = isset($qdnew_discount)?floatval($qdnew_discount):0;
		$qdnew_type = isset($qdnew_type)?trim($qdnew_type):"percent";
		$qdnew_wholesale = isset($qdnew_wholesale)?"Yes":"No";
		$qdnew_freeshipping = isset($qdnew_freeshipping)?"Yes":"No";
		
		if ($qdnew_min > 0 || $qdnew_max > 0)
		{
			$db->reset();
			$db->assignStr("pid", $pid);
			$db->assignStr("is_active", $qdnew_active);
			$db->assignStr("range_min", $qdnew_min);
			$db->assignStr("range_max", $qdnew_max);
			$db->assignStr("discount", $qdnew_discount);
			$db->assignStr("discount_type", $qdnew_type);
			$db->assignStr("free_shipping", $qdnew_freeshipping);
			$db->assignStr("apply_to_wholesale", $qdnew_wholesale);
			$db->insert(DB_PREFIX."products_quantity_discounts");
		}

		//update old discounts
		$qd_active = isset($qd_active)?$qd_active:array();
		$qd_active = is_array($qd_active)?$qd_active:array();
		$qd_min = isset($qd_min)?$qd_min:array();
		$qd_min = is_array($qd_min)?$qd_min:array();
		$qd_max = isset($qd_max)?$qd_max:array();
		$qd_max = is_array($qd_max)?$qd_max:array();
		$qd_discount = isset($qd_discount)?$qd_discount:array();
		$qd_discount = is_array($qd_discount)?$qd_discount:array();
		$qd_type = isset($qd_type)?$qd_type:array();
		$qd_type = is_array($qd_type)?$qd_type:array();
		$qd_wholesale = isset($qd_wholesale)?$qd_wholesale:array();
		$qd_wholesale = is_array($qd_wholesale)?$qd_wholesale:array();
		$qd_freeshipping = isset($qd_freeshipping)?$qd_freeshipping:array();
		$qd_freeshipping = is_array($qd_freeshipping)?$qd_freeshipping:array();
		
		foreach ($qd_min as $qd_id=>$foo)
		{
			$db->reset();
			$db->assignStr("is_active", array_key_exists($qd_id, $qd_active)?"Yes":"No");
			$db->assignStr("range_min", $qd_min[$qd_id]);
			$db->assignStr("range_max", $qd_max[$qd_id]);
			$db->assignStr("discount", $qd_discount[$qd_id]);
			$db->assignStr("discount_type", $qd_type[$qd_id]);
			$db->assignStr("free_shipping", array_key_exists($qd_id, $qd_freeshipping)?"Yes":"No");
			$db->assignStr("apply_to_wholesale", array_key_exists($qd_id, $qd_wholesale)?"Yes":"No");
			$db->update(DB_PREFIX."products_quantity_discounts", "WHERE pid='".intval($pid)."' AND qd_id='".$qd_id."'");
		}

		/**
		 * Product families
		 */
		$db->query("DELETE FROM ".DB_PREFIX."products_families_dependencies WHERE pid='".intval($pid)."'");
		
		//Add new families
		$pf = explode(",", $product_families);
		
		for ($i=0; $i < count($pf); $i++)
		{
			$pf_id = intval($pf[$i]);
			
			if ($pf_id)
			{
				$db->reset();
				$db->assign("pid", $pid);
				$db->assign("pf_id", $pf_id);
				$db->insert(DB_PREFIX."products_families_dependencies");
			}
		}

		/**
		 * Products gifts
		 */
		$db->query("DELETE FROM ".DB_PREFIX."products_gifts WHERE pid='".$pid."'");
		//Add new families
		$pg = explode(",", $product_gifts);
		for ($i=0; $i < count($pg); $i++)
		{
			$gift_code = ($pg[$i]);
			$cc = explode("|", $gift_code);

			if (count($cc) == 4)
			{
				$db->reset();
				$db->assign("pid", $pid);
				$db->assign("gift_pid", intval($cc[0]));
				$db->assign("gift_quantity", intval($cc[1]));
				$db->assignStr("gift_shipping_free", $cc[2]);
				$db->assignStr("gift_max_quantity", $cc[3]);
				$db->insert(DB_PREFIX."products_gifts");
			}
		}

		/**
		 * Inventory control
		 */
		if ($inventory_control == "AttrRuleExc" || $inventory_control == "AttrRuleInc")
		{
			
			$passedUniqueSubIds = true;
			
			// Check for unique inventory subids
			if (isset($inv_arr_subid) && !empty($inv_arr_subid))
			{
				$inventoryMap = array();
				foreach ($inv_arr_subid as $inventory_id => $subid)
				{
					$inventoryMap[] = trim(strtolower($subid));
				}

				if (count($inv_arr_subid) != count(array_unique($inventoryMap)) || (isset($inv_attr_subid) && trim($inv_attr_subid) != '' && in_array(trim($inv_attr_subid), $inventoryMap)))
				{
					$adminView->assign('PageNote', array(
						array("class"=>"ic-cross", "text"=>"<b>Duplicate or blank inventory sub id detected, please correct and try saving again.</b>", "url"=>"", "visible"=>true)
					));
					$passedUniqueSubIds = false;
				}
			}
			
			if ($passedUniqueSubIds)
			{
				//add new
				if (isset($inv_attr_subid) && $inv_attr_subid != "")
				{
					$db->query("
						SELECT * FROM ".DB_PREFIX."products_attributes
						WHERE pid='".$pid."' AND is_active='Yes' AND track_inventory=1 AND (attribute_type='radio' OR attribute_type='select')
						ORDER BY priority, name, is_modifier
					");
				
					$attributes_hash = "";
					$attributes_list = "";
				
					while ($db->moveNext())
					{
						$attributes_hash = $attributes_hash.($attributes_hash == "" ? "" : "\n").$db->col["paid"].": ".$inv_attribute_option[$db->col["paid"]];
						$attributes_list = $attributes_list.($attributes_list == "" ? "" : "\n").$db->col["name"].": ".$inv_attribute_option[$db->col["paid"]];
					}
				
					$_hash = md5($attributes_hash);
					$db->query("SELECT * FROM ".DB_PREFIX."products_inventory WHERE pid='".$pid."' AND attributes_hash='".$db->escape($_hash)."'");
					
					if ($db->moveNext())
					{
						$pi_id = $db->col["pi_id"];
						$db->reset();
						$db->assignStr("pid", $pid);
						$db->assignStr("product_subid", $inv_attr_subid);
						$db->assignStr("stock", $inv_attr_stock);
						$db->assignStr("stock_warning", $inv_attr_stock_warning);
						$db->assignStr("is_active", isset($inv_attr_active)?"1":"0");
						$db->assignStr("attributes_hash", $_hash);
						$db->assignStr("attributes_list", $attributes_list);
						$db->update(DB_PREFIX."products_inventory", "WHERE pi_id='".$pi_id."' AND pid='".$pid."'");
					}
					else
					{
						if ($productAttribute->isInventorySubIdUnique($pid, null, $inv_attr_subid))
						{
							$db->reset();
							$db->assignStr("pid", $pid);
							$db->assignStr("product_subid", $inv_attr_subid);
							$db->assignStr("stock", $inv_attr_stock);
							$db->assignStr("stock_warning", $inv_attr_stock_warning);
							$db->assignStr("is_active", isset($inv_attr_active)?"1":"0");
							$db->assignStr("attributes_hash", $_hash);
							$db->assignStr("attributes_list", $attributes_list);
							$pi_id = $db->insert(DB_PREFIX."products_inventory");
						}
					}
				}

				//update inventory on attribute level
				if (isset($inv_arr_stock) && isset($inv_arr_stock_warning) && isset($inv_arr_subid))
				{
					$inv_arr_active = isset($inv_arr_active)?$inv_arr_active:array();
					foreach ($inv_arr_stock as $pi_id=>$ffooo)
					{
						$arr_stock = $inv_arr_stock[$pi_id];
						$arr_stock = $arr_stock < 0 ? 0 : $arr_stock;
						$arr_stock_warning = $inv_arr_stock_warning[$pi_id];
						$arr_stock_warning = $arr_stock_warning < 0 ? 0 : $arr_stock_warning;
						$db->reset();
						$db->assignStr('product_subid', $inv_arr_subid[$pi_id]);
						$db->assign("is_active", array_key_exists($pi_id, $inv_arr_active)?"1":"0");
						$db->assign("stock", $arr_stock);
						$db->assign("stock_warning", $arr_stock_warning);
						$db->update(DB_PREFIX."products_inventory", "WHERE pi_id='".intval($pi_id)."'");
						//echo $db->query."<br/>";
					}
				}
			}
			
			//update inventory on product level
			$db->query("SELECT SUM(stock) AS products_stock FROM ".DB_PREFIX."products_inventory WHERE pid='".$pid."'");
			$db->moveNext();
			$stock = $db->col["products_stock"];
			$db->reset();
			$db->assignStr("stock", $stock);
			$db->assignStr("stock_warning", 0);
			$db->update(DB_PREFIX."products", "WHERE pid='".$pid."'");
		}
	}

	//set new attributes count
	if (!DEMO_LOCK)
	{
		updateProductAttributesCount($db, $pid);
	}

	$adminView->assign('do_apply', $do_apply);
	$adminView->assign('pid', $pid);
	$adminView->assign('duplicate_product_id', $duplicate_product_id);
	$adminView->assign('last_active_tab', $last_active_tab);

	if (!is_null($prev_pid) || !is_null($next_pid))
	{
		$adminView->assign('PageNote2', array(
			array("class"=>"ic-pencil", "text"=>"Edit Prev Product in List", "url"=>"admin.php?p=product&mode=update&pid=".(is_null($prev_pid)? 0 : $prev_pid),  "visible" => !is_null($prev_pid)),
			array("class"=>"ic-pencil", "text"=>"Edit Next Product in List", "url"=>"admin.php?p=product&mode=update&pid=".(is_null($next_pid)? 0 : $next_pid),  "visible" => !is_null($next_pid))
		));
	}

	if ($last_active_tab != 'main' || $do_apply || $duplicate_product_id)
	{
		header('Location: admin.php?p=product&mode=update&pid='.$pid.($duplicate_product_id ? '&dw=true' : '' ).'&last_active_tab='.$last_active_tab);
		_session_write_close();
		$db->done();
		die();
	}

	$adminView->render('pages/product/product-process');
