<?php
	if (!defined("ENV")) exit();
?>
<div class="admin-form-header">
	<div class="admin-form-header-buttons">
		<a href="<?php echo $_SERVER["PHP_SELF"]."?".($_SERVER["QUERY_STRING"]);?>&printing" target="_blank" title="Print Report"><span class="icon ic-icon ic-printer"></span></a>
	</div>
	<span class="icon ic-icon ic-list"></span>Total Profit For (<?php echo GetReportDate();?>)
</div>
<?php
	$db->query("
		SELECT
			COUNT(profit) AS num_records, 
			SUM(profit) AS profit,
			SUM(total_cost) AS total_cost,
			SUM(total_amount) AS total_amount
		FROM 
			(SELECT
					o.oid,
					SUM(((oc.price - oc.cost) * oc.quantity) * (1 - o.gift_cert_amount / o.total_amount)) AS profit,
					SUM((oc.cost * oc.quantity) * (1 - o.gift_cert_amount / o.total_amount)) AS total_cost,
					o.subtotal_amount * (1 - o.gift_cert_amount / o.total_amount) AS total_amount
			FROM ".DB_PREFIX."orders_content oc
			JOIN ".DB_PREFIX."orders o ON  o.oid = oc.oid
			WHERE 
					o.removed='No' AND
					o.status='Completed' AND 
					o.payment_status='Received' AND
					(o.placed_date BETWEEN '".$mysql_from."' AND '".$mysql_to."') AND
					oc.cost > 0
			GROUP BY o.oid
		) AS tmp_profit
	");
	
	$db->moveNext();
	
	if (intval($db->col['num_records'])>0)
	{
?>
<table width="100%" cellpadding="0" cellspacing="0" border="0" class="admin-list-table admin-stat-table">
	<thead>
		<tr>
			<th class="item-num">&nbsp;</th>
			<th>Total Cost</th>
			<th>Total Income</th>
			<th>Total Profit</th>
		</tr>
	</thead>
	<tbody>
		<tr>
			<td>&nbsp;</td>
			<td><?php echo getAdminPrice($db->col['total_cost']);?></td>
			<td><?php echo getAdminPrice($db->col['total_amount']);?></td>
			<td><?php echo getAdminPrice($db->col['profit']);?></td>
		</tr>
	</tbody>
</table>
<?php
	}
	else
	{
		pageNote(array(
			array("class"=>"ic-info", "text"=>"No data available for selected period", "url"=>"", "visible"=>true)
		));
	}
