<?php
if (!defined("ENV")) exit();

global $settings;

$rows = $db->selectAll('SELECT  l.amount, l.unique_id, l.invoice,
	DATE_FORMAT(l.timestamp, \''.$settings["LocalizationDateTimeFormat"].'\') as timestamp,
	CONCAT(CONCAT(u.fname, \' \'), u.lname) as customer_name,
	o.order_num,
	o.status
FROM '.DB_PREFIX.'shift4_timeout_log l
  INNER JOIN '.DB_PREFIX.'orders o on l.oid = o.oid
  LEFT OUTER JOIN '.DB_PREFIX.'users u on o.uid = u.uid
WHERE l.timestamp >= \''.$mysql_from.'\' and l.timestamp <= \''.$mysql_to.'\'
ORDER BY timestamp
');
?>

<table width="100%" cellpadding="0" cellspacing="0" border="0" class="admin-list-table">
	<thead>
	<tr>
		<th>Order ID</th>
		<th class="item-num">Invoice</th>
		<th>Customer</th>
		<th>Transaction Date</th>
		<th>Unique Id</th>
		<th>Amount</th>
	</tr>
	</thead>
	<tbody>
	<?php foreach ($rows as $row) {
		?>
		<tr>
			<td><?php echo $row['order_num']; ?></td>
			<td><?php echo $row['invoice']; ?></td>
			<td><?php echo $row['customer_name']; ?></td>
			<td><?php echo $row['timestamp']; ?></td>
			<td><?php echo $row['unique_id']; ?></td>
			<td><?php echo getAdminPrice($row['amount']); ?></td>
		</tr>
	<?php
	}
	?>
	</tbody>
</table>