<?php

	if (!defined('ENV')) exit();

	$request = Framework_Request::createFromGlobals();

	$action = $request->get('action');

	$exactor = new Admin_Controller_Exactor($request, $db);

	// TODO: move this check from here in some class / function
	if (
		$settings['CompanyName'] == 'Company Name' || $settings['CompanyName'] == '' ||
		$settings['CompanyAddressLine1'] == 'Address Line 1' || $settings['CompanyAddressLine1'] == '' ||
		$settings['CompanyState'] == 'State' || $settings['CompanyState'] == '' ||
		$settings['CompanyZip'] == '-' || $settings['CompanyZip'] == ''
	)
	{
		Admin_Flash::setMessage(
			'To calculate taxes using Exactor, please make sure you have updated your <a href="admin.php?p=settings&group=1">Company Information</a> under Global Cart Settings. '.
			'Please note: Exactor requires a valid address',
			Admin_Flash::TYPE_ERROR
		);
	}

	if (!is_null($action))
	{
		$actionCalled = true;

		switch ($action)
		{
			case 'save_exactor' : $exactor->manageAction(); break;
			case 'update_euc' : $exactor->updateEucAction(); break;
			case 'save_tax_codes' : $exactor->manageTaxCodesAction(); break;
			case 'delete_tax_code' : $exactor->deleteTaxCode(); break;
			case 'add_euc_code' : $exactor->addEucCode(); break;
			default : $actionCalled = false; break;
		}
	}
	else
	{
		$actionCalled = false;
	}

	if (!$actionCalled)
	{
		$lastActiveTab = isset($_REQUEST['last_active_tab']) ? $_REQUEST['last_active_tab'] : 'main';

		switch ($lastActiveTab)
		{
			case 'settings': $exactor->manageAction(); break;
			case 'tax-codes': $exactor->manageTaxCodesAction(); break;
			default: $exactor->aboutAction(); break;
		}
	}

