$(document).ready(function(){
	$("#formTaxClassProducts").submit(function(){return false;});
	
	$("#selectCategories").change(function(){
		$("#buttonSaveChanges").attr("disabled", "disabled");
		var selectedCategories = [];
		$('#selectCategories :selected').each(function(i, selectedOption){
			selectedCategories[i] = $(selectedOption).val();
		});
		$.getJSON("admin.php?chart=true&p=taxes_class&mode=getProducts&categories=" + escape(selectedCategories), function(data){
			var assigned = 0;
			var current_tax_class_id = $("#tax_class_id").val();
			$("#selectProducts").html("");
			$(data.products).each(function(i, product){
				var o = $("<option></option>").val(product.pid).html(product.title);
				if (product.tax_class_id == current_tax_class_id)
				{
					$(o).attr("selected", "selected");
					assigned++;
				}
				$("#selectProducts").append(o);
			});
			$("#divProductsTitle").html("Products (found " + data.count + ", " + assigned + " assigned)");
			$("#buttonSaveChanges").removeAttr("disabled");
		});
	});
	
	$('#selectCategories').change();
	
	$("#buttonSaveChanges").click(function(){
		$("#buttonSaveChanges").attr("disabled", "disabled");
		var current_tax_class_id = $("#tax_class_id").val();
		var selectedCategories = [];
		$('#selectCategories :selected').each(function(i, selectedOption){
			selectedCategories[i] = $(selectedOption).val();
		});
		var selectedProducts = [];
		$('#selectProducts :selected').each(function(i, selectedOption){
			selectedProducts[i] = $(selectedOption).val();
		});
		
		$.getJSON("admin.php?chart=true&p=taxes_class&mode=assignProducts&class_id=" + escape(current_tax_class_id) + "&categories=" + escape(selectedCategories) + '&products=' + escape(selectedProducts), function(data){
			if (data.result)
			{
				$("#divProductsTitle").html("Products (found " + $('#selectProducts option').length + ", " + $('#selectProducts option:selected').length + " assigned)");
			}
			$("#buttonSaveChanges").removeAttr("disabled");
		});
	});
});