<?php

return array(
	'common' => array(
		'yes' => 'Yes',
		'no' => 'No',
		'save_changes' => 'Save Changes',
		'reset' => 'Reset form',
		'required_fields_bold' => 'Please note: required fields are <string>bold</string>',
		'all_countries' => 'All Countries',
		'all_states_provinces' => 'All States/Provinces',
		'month' => array(
			1 => 'Jan',
			2 => 'Feb',
			3 => 'Mar',
			4 => 'Apr',
			5 => 'May',
			6 => 'Jun',
			7 => 'Jul',
			8 => 'Aug',
			9 => 'Sep',
			10 => 'Oct',
			11 => 'Nov',
			12 => 'Dec'
		)
	),
	'admin' => array(
		'admin' => array(
			'site_administrator' => 'Site Administrator',
			'site_administrator_add' => 'Create a New Administrator Account',
			'site_administrator_update' => 'Update Administrator\'s Account',
			'remove' => 'Remove this account',
			'administrator_successfully_updated' => 'Administrator account has been successfully updated',
			'license_agreement' => '<strong>Your current license agreement only allows max_admins admin(s). Please contact your provider to upgrade your application.</strong>',
		),
		'profile' => array(
			'your_administrator_profile' => 'Your Administrator Profile',
			'leave_password_blank' => 'Please leave password field blank if you don\'t want to change it',
			'pci_change_password' => 'In order to comply with PCI security requirements, you must change your password now!',
			'pci_answer_question' => 'In order to comply with PCI security requirements, you must answer a security question now!',
			'pci_change_password_and_answer_question' => 'In order to comply with PCI security requirements, you must change your password and answer security question now!',
			'administrator_properties' => 'Administrator Properties',
			'basic_info' => 'Basic Information & Security',
			'name' => 'First &amp; last name',
			'email' => 'Email address',
			'email_mode_options' => array(
				'html' => 'HTML enriched messages',
				'text' => 'Plain text messages',
			),
			'email_mode' => 'Email notifications',
			'notification_options' => array(
				'invoice' => 'Receive invoice notifications',
				'outofstock' => 'Receive out of stock notifications',
				'signup' => 'New user registration notifications',
				'security_audit' => 'Receive security audit emails',
				'notactive' => 'Notify me if an administrator account has been inactive for over 90 days',
				'product_review' => 'Email admin when a review is created',
			),
			'pwdchange_options' => array(
				'pwdchange30' => '30 days',
				'pwdchange60' => '60 days',
				'pwdchange90' => '90 days',
				'pwdchangenever' => 'Never',
			),
			'pwdchange' => 'Remind me to change password after',
			'username' => 'Username',
			'password' => 'Password',
			'password_hint' => 'Password must be at least 8 characters long, contain lower and upper case letters, and have at least one numeric or special character',
			'password2' => 'Password confirmation',
			'force_password_change' => 'Force password reset on next login?',
			'qb_account' => 'Quickbooks account',
			'qb_account_linked' => 'Linked (<a href="admin.php?p=profile_openid&chart=true&unlink=true">Unlink</a>)',
			'qb_account_unlinked' => 'Unlinked (<a href="admin.php?p=profile_openid&chart=true">Link</a>)',
			'account_lock_grp' => 'Account Lock',
			'active' => 'Current status',
			'active_options' => array(
				'yes' => 'Unlocked',
				'no' => 'Locked',
			),
			'expiration' => 'Expiration',
			'expires' => 'Does this account expire?',
			'expiration_date' => 'Expiration date',
			'security_question' => 'Security question',
			'security_question_not_selected' => 'Please choose security question',
			'security_question_1' => 'What is the middle name of your oldest child?',
			'security_question_2' => 'What school did you attend for sixth grade?',
			'security_question_3' => 'In what city did you meet your spouse/significant other?',
			'security_question_4' => 'What was your childhood nickname?',
			'security_question_5' => 'What street did you live on in third grade?',
			'security_question_6' => 'What was the name of your first stuffed animal?',
			'security_question_7' => 'What is your oldest sibling\'s middle name?',
			'security_question_answer' => 'Security question answer',
			'privileges_group' => 'Your Privileges',
			'privileges_options' => array(
				'categories' => 'Manage product categories',
				'products' => 'Add/edit/delete products, bulk loaders',
				'users' => 'Manage site users',
				'orders' => 'Manage orders',
				'emails' => 'Edit and send emails',
				'admins' => 'Manage site administrators',
				'global' => 'Edit global site settings',
				'business' => 'Manage payment, shipping, taxes and discounts',
				'content' => 'Manage site content (pages, themes, colors and files)',
				'export' => 'Clear / Export MySQL database',
				'stats' => 'See statistics',
				'marketing' => 'Marketing',
				'ccs' => 'Access to CCS',
				'demo' => 'Demo Mode Admin',
				'all' => 'All privileges',
			),
			'notes' => array(
				'qb_account' => 'To Connect to Quickbooks to sync your products, customers, and orders, <a href="admin.php?p=settings_intuit">Click here</a>',
			),
		),
		'account_created' => 'Administrator account has been successfully created.',
	),
	'seo' => array(
		'notes' => array(
			'metatitle' => 'Max 69 characters.',
			'metadescription' => 'Max 156 characters.',
			'metakeywords' => 'Separate keywords and phrases by using a comma.',
		),
	),
	'stamps' => array(
		'settings' => array(
			'scan' => array(
				'title_generate' => 'Generate Shipment Confirmation Acceptance Notice (SCAN)',
				'title_search' => 'Search Previously Generated Scan Forms',
				'shipment_date' => 'Shipment Date',
				'search_date' => 'Search for Date',
				'no_results_for_date' => 'There are no shipments found for selected date',
				'no_forms_for_date' => 'There are no SCAN forms found for selected date',
			),
			'pickup' => array(
				'title_options' => 'Carrier Pickup Options',
				'pickup_date' => 'Pickup date',
				'pickup_date_note' => 'Prepopulate for this date labels',
				'no_results_for_date' => 'There are no shipments found for selected date',
				'express_mail_pieces' => 'Number of Express Mail pieces',
				'priority_mail_pieces' => 'Number of Priority Mail pieces',
				'international_mail_pieces' => 'Number of International Mail pieces',
				'other_mail_pieces' => 'Number of other mail pieces',
				'other_mail_pieces_note' => 'Number of mail pieces not included in above three categories',
				'total_weight' => 'Total weight, Lbs',
				'total_weight_note' => 'Total weight of packages in pounds. Will be rounded to the next higher value.',
				'title_address' => 'Pickup Location',
				'first_name' => 'First name',
				'last_name' => 'Last name',
				'company' => 'Company name',
				'address' => 'Street address',
				'suite' => 'Suite or apartment number',
				'city' => 'City',
				'state' => 'State',
				'zip' => 'Zip code',
				'zip4' => 'Zip-4 code',
				'phone' => 'Phone number without extension',
				'phone_note' => 'Numbers only, no spaces, no dashes',
				'phone_ext' => 'Phone number extension',
				'pickup_location' => 'Carrier pickup location',
				'pickup_location_options' => array(
					'FrontDoor' => 'Packages are at front door',
					'BackDoor' => 'Packages are at back door',
					'SideDoor' => 'Packages are at side door',
					'KnockOnDoorOrRingBell' => 'Carrier needs to knock on door or ring bell to get the packages',
					'MailRoom' => 'Packages are in mail room',
					'Office' => 'Packages are in office',
					'Reception' => 'Packages are at reception area',
					'InOrAtMailbox' => 'Packages are in mail box',
					'Other' => 'Packages are at the location other than above places'
				),
				'pickup_location_options_note' => 'When "Other" selected then special instruction must be provided',
				'instructions' => 'Special instructions',
				'error_cannot_get_data' => 'Cannot process Stamps.com request at this moment. Please try again later.',
				'request_sent' => 'Carrier pickup request has been sent to USPS.<br>Confirmation number:'
			)
		)
	),
	'tax_settings' => array(
		'tax_settings' => 'Tax Settings',
		'display_prices_with_tax' => 'Display Prices with Tax?',
		'display_prices_with_tax_options' => array(
			'yes' => 'Yes',
			'included' => 'Prices include Tax',
			'no' => 'No',
		),
		'tax_address' => 'Apply Tax to Orders By',
		'tax_address_options' => array(
			'shipping' => 'Order Shipping Address, or Billing Address if there is no shipping',
			'billing' => 'Order Billing Address',
			'default' => 'Default Tax Country / State (see below)',
		),
		'notes' => array(
			'display_prices_with_tax' => '',
		),
		'default_tax_country' => 'Default Tax Country',
		'default_tax_state' => 'Default Tax State / Province',
		'enable_tax_exemptions' => 'Enable Tax Exemptions',
		'enable_tax_exemptions_options' => array(
			'no'=>'No',
			'yes'=>'Yes'
		)
	),
);