<?php
$include_path = "../../../";
require_once($include_path."engine/engine_config.php");
require_once($include_path."engine/engine_mysql.php");
require_once($include_path."engine/engine_localization.php");
require_once($include_path."engine/engine_functions.php");
require_once($include_path."engine/engine_order.php");
require_once($include_path."classes/class.plugins.php");
require_once($include_path."vendors/smarty/Smarty.class.php");

$db = new DB;
$db->init(DB_HOST, DB_USER, DB_PASSWORD, DB_NAME);

require_once($include_path."engine/engine_settings.php");
require($include_path."engine/engine_url_".($settings["USE_MOD_REWRITE"] == "YES" ? "rewrite" : "default").".php");
$smarty = new Smarty();
$smarty->template_dir = "templates";
$smarty->compile_dir = "templates/compile";
session_cache_limiter("nocache");


$username = isset($_REQUEST["username"])?trim($_REQUEST["username"]):"";
$password = isset($_REQUEST["password"])?trim($_REQUEST["password"]):"";
$token = isset($_REQUEST["token"])?trim($_REQUEST["token"]):"";

// check auth
$plugin_auth = true;
//$plugin_in_auth = true;

$plugin_active = $settings["plugin_openapi_active"];
$plugin_username = $settings["plugin_openapi_username"];
$plugin_password = $settings["plugin_openapi_password"];
$plugin_token = $settings["plugin_openapi_token"];
$global_http_url = $settings["GlobalHttpUrl"];

if ($plugin_active == "NO" || $plugin_username != $username || checkPasswordHash($password, $plugin_password))
{
    if ($plugin_token != $token)
    {
        $plugin_auth = false;
    }
//    if ($plugin_in_token != $token)
//    {
//        $plugin_in_auth = false;
//    }
}

if ($plugin_auth)
{
        if ($_SERVER["SERVER_PORT"] != 443 && !defined("DEVMODE"))
        {
                $plugin_auth = false;
        }
}
?>