<?php

/**
 * Countries Repository
 */

class DataAccess_CountryRepository extends DataAccess_Repository
{
	/**
	 * Get countries list
	 *
	 * @param bool $cache
	 *
	 * @return type
	 */
	public function getCountries($cache = true)
	{
		return $this->getData('SELECT * FROM '.DB_PREFIX.'countries ORDER BY country_priority DESC, name', $cache);
	}

	/**
	 * Get country by id
	 *
	 * @param $countryId
	 * @param bool $cache
	 *
	 * @return type
	 */
	public function getCountryById($countryId, $cache = false)
	{
		return $this->getOne('SELECT * FROM '.DB_PREFIX.'countries WHERE coid='. intval($countryId));
	}
}