<?php

if (isset($settings['AvalaraEnableTax']) && $settings['AvalaraEnableTax'] == 'Yes')
{
	Events_EventHandler::registerListener(
		Events_OrderEvent::ON_STATUS_CHANGE,
		array('Tax_Avalara_AvalaraListener', 'onOrderStatusChange')
	);

	Events_EventHandler::registerListener(
		Events_OrderEvent::ON_DELETED,
		array('Tax_Avalara_AvalaraListener', 'onOrderDeleted')
	);
}
else if (isset($settings['ExactorEnableTax']) && $settings['ExactorEnableTax'] == 'Yes')
{
	Events_EventHandler::registerListener(
		Events_OrderEvent::ON_STATUS_CHANGE,
		array('Tax_Exactor_ExactorListener', 'onOrderStatusChange')
	);

	Events_EventHandler::registerListener(
		Events_OrderEvent::ON_DELETED,
		array('Tax_Exactor_ExactorListener', 'onOrderDeleted')
	);
}

Events_EventHandler::registerListener(
	Events_OrderEvent::ON_STATUS_CHANGE,
	array('Listener_GiftCertificate', 'onOrderStatusChange')
);

Events_EventHandler::registerListener(
	Events_OrderEvent::ON_STATUS_CHANGE,
	array('Listener_StockControl', 'onOrderStatusChange')
);

Events_EventHandler::registerListener(
	Events_OrderEvent::ON_STATUS_CHANGE,
	array('Listener_ProductLocations', 'onOrderStatusChange')
);

Events_EventHandler::registerListener(
	Events_OrderEvent::ON_ADD_ITEM,
	array('Listener_QuantityDiscounts', 'checkQuantityDiscounts')
);

Events_EventHandler::registerListener(
	Events_OrderEvent::ON_UPDATE_ITEMS,
	array('Listener_QuantityDiscounts', 'checkQuantityDiscounts')
);

Events_EventHandler::registerListener(
	Events_OrderEvent::ON_REMOVE_ITEM,
	array('Listener_QuantityDiscounts', 'checkQuantityDiscounts')
);

Events_EventHandler::registerListener(
	Events_OrderEvent::ON_ADD_ITEM,
	array('Listener_ProductGifts', 'checkFreeProducts')
);

Events_EventHandler::registerListener(
	Events_OrderEvent::ON_UPDATE_ITEMS,
	array('Listener_ProductGifts', 'checkFreeProducts')
);

Events_EventHandler::registerListener(
	Events_OrderEvent::ON_REMOVE_ITEM,
	array('Listener_ProductGifts', 'checkFreeProducts')
);