<?php
/*	DataCash PHP API

	$Id: DataCash_UserAgent.php,v 1.2.2.2 2006/06/05 16:56:30 victor Exp $
	
	This module is used to build an XML document

	Usage:

	Author: Dave MacRae

	Copyright: DataCash Group plc 2003
	Changelog:
		dem: 2002-05-23 Added CVS ID tag and class logger

*/


$CVSid = explode (" ", "$Id: DataCash_UserAgent.php,v 1.2.2.2 2006/06/05 16:56:30 victor Exp $");
$included_classes{basename($CVSid{1}, ".php,v")} = $CVSid{2};

function DataCash_UserAgent (&$doc) {

  global $included_classes;
	
  $os = php_uname();
  $doc->set ("Request.UserAgent.architecture", $os);
  $doc->set ("Request.UserAgent.language", "PHP", array('version' => phpversion()));
	
  $doc->set("Request.UserAgent.Libraries", "", array('bundle' => "DataCash-XML-PHP", 'version' => $included_classes{"Bundle"}));
	
  foreach ($included_classes as $key => $value) {
    if ( $key != "Bundle" ) {
      $doc->set("Request.UserAgent.Libraries.lib", $key, array('version' => $value));
    }
  }
}

?>
