<?php

	if (!defined("ENV")) exit();

	// TODO: review this
	if (isset($_REQUEST['chart']))
	{
		echo 1; exit();
	}

	$adminView = Ddm_AdminView::getInstance();
	
	$adminView->assign('labelAppName', $label_app_name);
	$adminView->assign('labelAppNameMd5', md5($label_app_name));
	$adminView->assign('licenseNumberEncoded', base64_encode(LICENSE_NUMBER));
	$adminView->assign('isLabeledApp', IS_LABEL ? 1 : 0);
	
	$adminView->assign('authAdminName', $auth_admin_name);
	$adminView->assign('todayDate', date("F j, Y"));
	
	/**
	 * "install" dir warning
	 */
	$installDirWarning = false;
	if (is_dir("install"))
	{
		if (isset($_REQUEST["remove_install"]))
		{
			remove_dir("install");
			
			if (!is_dir("install"))
				$installDirWarning = 'Thank You. "install" folder has been successfully removed';
			else
				$installDirWarning = 'Cannot remove "install" folder. Please check folder permissions. Please <a href="admin.php?p=home&remove_install=true">click here</a> to try again';
		}
		else
		{
			$installDirWarning = 'Your cart is already installed. It is strongly recommended to remove the "install" folder. Please <a href="admin.php?p=home&remove_install=true">click here</a> to do it now';
		}
	}
	
	$adminView->assign('installDirWarning', $installDirWarning);

	if ($settings['intuit_anywhere_connected'] == 'Yes')
	{
		$db->query("SELECT COUNT(*) FROM ".DB_PREFIX."admin_oauth");
		if (($row = $db->moveNext()) && $row['0'] == 0)
		{
			$db->query("UPDATE ".DB_PREFIX."settings SET value = 'No' WHERE name = 'intuit_anywhere_connected'");
			$settings['intuit_anywhere_connected'] = 'No';
		}
	}

	$adminView->assign('AdminShowTrialForm', defined('TRIAL_MODE') && TRIAL_MODE && $iono->level == 99 && $settings['AdminShowTrialForm'] == '1' ? 1 : 0);

	/**
	 * Display quickbooks interview
	 */
	if (((defined('IS_INTUIT_FEDERATED') && IS_INTUIT_FEDERATED) || $settings['intuit_anywhere_connected'] == 'Yes') && $settings['intuit_income_account'] == '')
	{
		require_once 'content/vendors/intuit/oauth/config.php';

		if (!isset($intuitSync)) $intuitSync = intuit_Services_QBSync::create();

		$intuitQuickStart = new Admin_Intuit_QuickStart($db, $settings, Ddm_AdminView::getInstance(), $intuitSync);
		$adminView->assign('intuitQuickStart', $intuitQuickStart->action_render());
	}
	else
	{
		if (defined('INTUIT_TRIAL') && INTUIT_TRIAL && $settings['intuit_anywhere_connected'] == '')
		{
			$connectUrl = intuit_ServiceLayer::getConnectUrl(false);
			$db->query("SELECT COUNT(*) FROM ".DB_PREFIX."admins WHERE aid=".intval($admin_auth_id).' AND openid <> \'\'');
			if ($row = $db->moveNext())
			{
				if ($row['0'] == 0)
				{
					$connectUrl = $settings['GlobalHttpsUrl'].'/admin.php?p=profile_openid&chart=true&force=true';
				}
			}
			$adminView->assign('connectUrl', $connectUrl);
			$adminView->assign('intuitDirectConnect', true);
		}
		$adminView->assign('intuitQuickStart', false);
	}
	
	/**
	 * PayPal
	 */
	if (isset($_REQUEST["action"]))
	{
		if ($_REQUEST["action"] == "hide-paypal")
		{
			$db->query("UPDATE ".DB_PREFIX."settings SET value='0' WHERE name='paypal_on_home_page'");
		}
	}
	
	$db->query("SELECT COUNT(*) AS c FROM ".DB_PREFIX."payment_methods WHERE id = 'paypalec' AND active = 'Yes' LIMIT 1");
	$db->moveNext();
	$adminView->assign('showPaypal', $settings["paypal_on_home_page"] == "1" && intval($db->col['c']) == 0);
	
	$adminView->assign('intuitToolIconEnabled', _ACCESS_INTUIT_ANYWHERE);
	
	/**
	 * Stats
	 */
	if (isPrivilege($auth_rights, array("all", "stats")))
	{
		$adminView->assign('showStats', true);
		$statRepository = DataAccess_Repository::get('StatRepository');
		$adminView->assign('dayData', $statRepository->getBasicDayData());
		$adminView->assign('monthData', $statRepository->getBasicMonthData());

		$orderRepository = new DataAccess_OrderRepository($db);
		$adminView->assign('lastActiveOrders', $orderRepository->getLastActiveOrders($settings["LocalizationDateTimeFormat"]));
		$adminView->assign('lastActiveUsers', DataAccess_Repository::get('UserRepository')->getLastActiveUsers($settings["LocalizationDateTimeFormat"]));
	}
	else
	{
		$adminView->assign('showStats', false);
	}
	$adminView->assign('APP_VERSION', APP_VERSION);

	/**
	 * Render page
	 */
	print $adminView->render('pages/home/home');
	
	
	

