<?php
	if (!defined("ENV")) exit();
	
	$tiny_mce_pages_email = array('email_newsletter', 'email_updates', 'email_top_bottom');
	$tiny_mce_pages = array("category", "page", "payment_method", "product", "plugin");
?>
<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN" "http://www.w3.org/TR/html4/loose.dtd">
<html<?php if (_ACCESS_INTUIT_ANYWHERE && _CAN_ENABLE_INTUIT_ANYWHERE) { ?> xmlns="http://www.w3.org/1999/xhtml" xmlns:ipp="" <?php } ?>>
<head>
	<title><?php echo $label_app_name;?> Administrator Area</title>
	<meta http-equiv="Content-Type" content="text/html; charset=UTF-8"/>
	<style type="text/css"><!--
		@font-face {
			font-family:'Cabin';
			font-style:normal;
			font-weight: 400;
			src: local('Cabin Regular'), local('Cabin-Regular'), url('content/admin/styles/Cabin-Regular.ttf') format('truetype');
		}
		body {font-family:'Cabin',sans-serif;}
	--></style>
	<link rel="stylesheet" type="text/css" href="content/vendors/jquery/ui/themes/smoothness/smoothness.css" />
	<link rel="stylesheet" type="text/css" href="content/vendors/jquery/treeview/jquery.treeview.css"/>
	<link rel="stylesheet" type="text/css" href="content/vendors/jquery/colorpicker/css/colorpicker.css" />
	<link rel="stylesheet" type="text/css" href="content/vendors/jquery/jgrowl/jquery.jgrowl.css"/>
	<link rel="stylesheet" type="text/css" href="content/admin/styles/admin.css?<?php echo APP_VERSION;?>" />
	<link rel="stylesheet" type="text/css" href="content/admin/styles/quick_start_guide.css?<?php echo APP_VERSION;?>" />
	<link rel="stylesheet" type="text/css" href="content/admin/styles/admin-menus.css?<?php echo APP_VERSION;?>" />
	<link rel="stylesheet" type="text/css" href="content/vendors/jquery/qtip/jquery.qtip-2.0.min.css?<?php echo APP_VERSION;?>" />
	<link rel="stylesheet" type="text/css" href="content/vendors/jquery/fancybox/jquery.fancybox-1.3.0.css" />
	
	<!--[if gte IE 6]>
	<style type="text/css">
	.quick-start-guide-pages ul li {display: inline;}
	</style>
	<![endif]-->
	<script type="text/javascript" language="JavaScript" src="content/vendors/json/json2-min.js"></script>
	<script type="text/javascript" language="JavaScript" src="content/vendors/jquery/jquery-1.9.1.min.js"></script>
	<script type="text/javascript" language="JavaScript" src="content/vendors/jquery/jquery-migrate/jquery-migrate-1.2.1.min.js"></script>
	<script type="text/javascript" language="JavaScript" src="content/vendors/jquery/ui/jquery-ui-1.10.3.custom.min.js"></script>
	<script type="text/javascript" language="JavaScript" src="content/vendors/jquery/treeview/jquery.treeview.js"></script>
	<script type="text/javascript" language="JavaScript" src="content/vendors/jquery/qtip/jquery.qtip-2.0.min.js"></script>
	<script type="text/javascript" language="JavaScript" src="content/vendors/jquery/fancybox/jquery.fancybox.js"></script>
	<script type="text/javascript" language="JavaScript" src="content/vendors/jquery/colorpicker/js/colorpicker.js"></script>
<?php
	if (in_array($p, array_merge($tiny_mce_pages_email, $tiny_mce_pages)))
	{
		$tinymce_config = (in_array($p, $tiny_mce_pages_email))
			? 'tiny_mce_email.js'
			: 'tiny_mce_common.js';
?>
	<script type="text/javascript" language="JavaScript" src="content/vendors/tinymce/tinymce.min.js"></script>
	<script type="text/javascript" language="JavaScript" src="content/admin/javascript/<?php echo $tinymce_config; ?>"></script>
<?php
	}
	
	loadJS('jquery.ddm.core.js');
	loadJS('common.js');
	loadJS('menus.js');
	loadJS('admin-menus.js');
	loadJS('kb.js');
	loadJS('forms.js');
	loadJS('quick_start_guide.js');
	loadJS('referral-dialog.js');

	$year = isset($year) ? intval($year) : date("Y");
	$month = isset($month) ? intval($month) : date("m");
?>
	<!--[if lte IE 8]><?php loadJS('excanvas.min.js', 'content/vendors/jquery/excanvas/'); ?><![endif]-->
	<script type="text/javascript">
		var chartDate = new Date();
		chartDate.setDate(1);
		chartDate.setFullYear(<?=$year;?>);
		chartDate.setMonth(<?=($month-1);?>);
	</script>
<?php
	loadJS('jquery.flot.min.js', 'content/vendors/jquery/flot/');
	loadJS('jquery.flot.pie.min.js', 'content/vendors/jquery/flot/');
	loadJS('jquery.flot.resize.js', 'content/vendors/jquery/flot/');
	loadJS('jquery.jgrowl_minimized.js', 'content/vendors/jquery/jgrowl/');
?>

	<script type="text/javascript" language="JavaScript">
		var GlobalHttpUrl = "<?php echo $settings["GlobalHttpUrl"]; ?>";
		var GlobalHttpsUrl = "<?php echo $settings["GlobalHttpsUrl"]; ?>";
		var hideMenus = <?php echo $hidemenus = isset($hidemenus)? 1 : 0; ?>;
		var autoOpenQuickStartGuide = <?php echo intval($auto_open_quickstart_guide); ?>;
		var autoOpenReferralDialog = <?php echo intval($auto_open_referral_dialog); ?>;
		var qsg_categoryLayout = null;
		var qsg_categoryDefaultView = null;
		var qsg_productLayout = null;
		var qsg_checkoutProcess = null;
		var adminAutoLogoutTimeInMinutes = <?php echo $settings["SecurityAdminTimeOut"]; ?>;
		var isFederated = <?php echo (isset($_SESSION["admin_federated"]) ? 1 : 0); ?>;
		var cartVersion = '<?php echo APP_VERSION;?>';
	</script>
<?php
	$intuitConnectionActive = false;
	$intuitConnected = false;

	if (_ACCESS_INTUIT_ANYWHERE) //$settings['intuit_anywhere_enabled'] == 'Yes')
	{ 
		require_once 'content/vendors/intuit/oauth/config.php';

		$oauth_token = isset($oauth_token) ? $oauth_token: '';
		$oauth_token_secret = isset($oauth_token_secret) ? $oauth_token_secret: '';
?>
<script type="text/javascript" src="https://js.appcenter.intuit.com/Content/IA/intuit.ipp.anywhere.js"></script>
<script>intuit.ipp.anywhere.setup({
	  menuProxy: '<?php echo $menu_proxy; ?>',
	  grantUrl: '<?php echo intuit_ServiceLayer::getGrantUrl(true); ?>'
	});</script>
<?php
		if ($settings['intuit_anywhere_enabled'] == 'Yes')
		{
			if ($settings['intuit_anywhere_connected'] == 'Yes' && $oauth_token != '')
			{
				$intuitConnectionActive = true;
				$intuitConnected = true;
			}
			else
			{
				$intuitConnectionActive = false;
				$intuitConnected = true;
			}
		}
	}
?>
	<script type="text/javascript" language="JavaScript">
		var intuitConnectionActive = <?php echo $intuitConnectionActive ? 1 : 0; ?>;
		var intuitConnected = <?php echo $intuitConnected ? 1 : 0; ?>;
	</script>
<?php
	$isTrial = (defined('TRIAL_MODE') && TRIAL_MODE && $iono->level == 99);
	if ($isTrial)
	{
?>
<style>
		body {margin-top:24px;}
		#jGrowl {margin-top:24px;}
<?php
		if ($intuitConnectionActive)
		{
?>
	body #intuitPlatformAppMenu { top: 30px; }
<?php 	} ?>
</style>
<script type="text/javascript">
  var _gaq = _gaq || [];
  _gaq.push(['_setAccount', 'UA-37633224-1']);
  _gaq.push(['_setDomainName', 'carttrial.com']);
  _gaq.push(['_trackPageview']);
  (function() {
    var ga = document.createElement('script'); ga.type = 'text/javascript'; ga.async = true;
    ga.src = ('https:' == document.location.protocol ? 'https://ssl' : 'http://www') + '.google-analytics.com/ga.js';
    var s = document.getElementsByTagName('script')[0]; s.parentNode.insertBefore(ga, s);
  })();
</script>
		<?php
	}
?>
</head>
<body <?=$isTrial?'style="margin-top:20px;"':''?>>
<?php
	if ($intuitConnectionActive)
	{
		echo '<div><ipp:blueDot></ipp:blueDot></div>';
	}
?>
	<div id="divAutoLogout" class="hidden" style="width:100%;">
		<div style="width:100%;">
			<div style="text-align:center;font-size:18px;padding:20px 0px 10px 0px;;font-weight:bold;color:black;">Your session expires in <span id="spanLogoutCountdown">xx</span> seconds</div>
			<div style="text-align:center;padding:15px;">
				<input type="button" id="buttonAutoLogoutNow" style="padding:5px 7px;" value="Logout now"/> &nbsp;
				<input type="button" id="buttonAutoLogoutCancel" style="padding:5px 7px;" value="Keep me logged in"/>
			</div>
		</div>
	</div>
<?php 
	if ($isTrial) {

		if (isset($_REQUEST['trialStarted']))
		{
			unset($_SESSION['admin_trial_token']);

			$db->query('UPDATE '.DB_PREFIX.'settings SET value="0" WHERE name="AdminShowTrialForm"');
			$settings['AdminShowTrialForm'] == '0';
		}
		
		$data = array(
			"l"=>LICENSE_NUMBER,
			'u' => false,
		);

		$expirationText = defined('LICENSE_EXPIRATION_TEXT') ? LICENSE_EXPIRATION_TEXT : '';

		$trialUpgradeUri = urlencode(base64_encode(serialize($data)));
?>
	<div id="trial-bar" style="left:0px;top:0px;position:fixed;width:100%;background-color:#161616;z-index:10000;color:#ffffff;padding:5px;min-height:15px;text-align:center;">
		Your trial will expire in <?php echo $expirationText;?>! &nbsp;
		<a href="https://account.<?php echo getp(); ?>.com/account/purchase-upgrade/<?php echo urlencode($trialUpgradeUri); ?>.html" target="_blank" style="color:#71980D;">Click here to Upgrade</a>
	</div>
<?php 
	}
?>
	<table cellpadding="0" cellspacing="0" border="0" width="100%" height="600" style="clear:both;<?php if ($isTrial) { ?>margin-top:28px;<?php } ?>">
		<tr valign="top">
			<td class="admin-zone-logo" <?php echo md5($label_app_name)=="aac9a3612c49dc1c1d5d4b756d07d789" ? 'style="background:black;"' : '';?>><a href="admin.php" title="Go to home page"><img src="images/admin/logo.<?php echo md5($label_app_name)=="aac9a3612c49dc1c1d5d4b756d07d789" ? "png" : "gif";?>" alt="Go to home page"/></a></td>
			<td class="admin-zone-header">
				<table cellpadding="0" cellspacing="0" border="0" width="100%">
					<tr>
						<td class="left">
							<!--<?php echo htmlspecialchars($label_app_name); ?>--> Version <?php echo $settings["AppVer"]; ?>
							<?php echo $iono->level == 99 ? " - <b>TRIAL CART</b>" : ""; ?>
							<!-- <strong><?php echo isSslMode() ? "HTTPS" : "HTTP"; ?> mode</strong>-->
							<?php echo (defined('DEMO_MODE') && DEMO_MODE && defined('DEMO_LOCK') && DEMO_LOCK) ? ' - <b>DEMO MODE</b>' : ""; ?>
		<?php
						if (($p == "home" || $p == "") && isPrivilege($auth_rights, array("all", "global")))
						{
							require_once("content/classes/class.update-client.php");
							$xmlParser = new XMLParser();

							$updateClient = new updateClient($db, $xmlParser);
							$fixes= $updateClient->checkForUpdates($update_script_url, LICENSE_NUMBER, $settings["AppVer"], $settings["AppEncoder"]);

							if (($fixes && $updateClient->new_updates))
							{
								echo " - Please note: <a href=\"admin.php?p=update\" style=\"color:#CC0000;font-weight:bold;text-decoration:underline;\">UPDATES ARE AVAILABLE</a>";
							}
						}
		?>
						</td>
						<td class="right <?php echo $intuitConnectionActive?'intuit':'';?>">
							<a href="admin.php?p=profile">Profile</a> <?php if (!isset($_SESSION["admin_federated"])) { ?>/
							<a href="javascript:confirmLogout()">Log Out</a><?php } ?>
		<?php
						if ((!defined('DEMO_MODE') || !DEMO_MODE) && $display_quick_start && (!defined('DEMO_LOCK') || !DEMO_LOCK) && isPrivilege($auth_rights, array("all")))
						{
		?>
							| <a id="quick-start-guide-link" href="#">Quick Start Guide</a>
		<?php
						}
						if (!IS_LABEL)
						{
		?>
							| <a id="video-tutorials-link" href="#">Video Tutorials</a>
		<?php
						}
		?>
						</td>
					</tr>
				</table>
			</td>
		</tr>
		<tr valign="top">
			<td class="admin-zone-menu">				
<?php
				require_once('content/admin/admin_layout_menu.php');
?>					
			</td>
			<td class="admin-zone-content">
				<div id="divHeader" style="display:none;">
					<div class="right">
						<table cellpadding="0" cellspacing="0" border="0" width="180">
							<tr>
								<td>
									<?php if (!isset($_SESSION["admin_federated"])) { ?>
									<div class="logout">
										<a style="" href="javascript:confirmLogout()">
											Log-out <img src="images/admin/bt_logout.gif" align="absmiddle" border="0" hspace="0" alt="Logout">
										</a>
										<form name="frmLogout" id="frmLogout" action="login.php" method="POST">
											<input type="hidden" name="action" value="logout"/>
										</form>
									</div>
									<div id="logout-countdown" style="padding-top:5px;clear:both;text-align:right;display:none;">
									</div>
									<?php } ?>
								</td>
							</tr>
						</table>
					</div>
				</div>
				
				
				
<?php
		/**
		 * Include page
		 */
		require("content/admin/".$body);
?>
				
				<img src="images/zerro.gif" width="800" height="1">
			</td>
		</tr>
	</table>
	<iframe name="iframe-download" id="iframe-download" style="display:none;width:1px;height:1px;" src=""></iframe>
	
<?php
	if (!IS_LABEL)
	{
?>
	<div id="kb-search-dialog" style="display:none;">
		<div id="kb-search-dialog-inner">
			<form id="kb-search-form" action="#" method="POST">
				To search our Knowledge Base, simply type in some terms specific to your search
				<br/>
				<table cellpadding="0" cellspacing="0" border="0">
					<tbody>
						<tr>
							<td><input id="kb-search-input" type="text"/></td>
							<td><input id="kb-search-button" type="submit" value="Search"/></td>
						</tr>
					</tbody>
				</table>
			</form>
			<div id="kb-search-result"></div>
		</div>
	</div>
			
	<div id="kb-search-answer-dialog" style="display:none;">
		<div id="kb-search-answer-dialog-inner"></div>
		<div>
			<input type="button" id="kb-search-answer-dialog-close" value=" Back "/>
		</div>
	</div>

	<div id="video-tutorials" style="display:none">
		Below is a sampling of tutorials designed to help you use the cart. You can view all of the tutorials by clicking <a href="http://<?php echo getp();?>.com/pinnacle-cart-videos.htm" target="_blank">here</a>
		<ul>
			<li><a class="video-tutorial-link" href="https://www.<?php echo getp();?>.com/video-tutorials-direct.htm?vfile=addingproduct">Adding a Product</a></li>
			<li><a class="video-tutorial-link" href="https://www.<?php echo getp();?>.com/video-tutorials-direct.htm?vfile=addingpaymentmethod">Enabling a Payment Method</a></li>
			<li><a class="video-tutorial-link" href="https://www.<?php echo getp();?>.com/video-tutorials-direct.htm?vfile=shippingquotes">Enabling the Shipping Quote Feature</a></li>
			<li><a class="video-tutorial-link" href="https://www.<?php echo getp();?>.com/video-tutorials-direct.htm?vfile=secondaryimages">Adding Secondary Images</a></li>
			<li><a class="video-tutorial-link" href="https://www.<?php echo getp();?>.com/video-tutorials-direct.htm?vfile=creatingattributes">Adding Attributes (size, color, etc)</a></li>
			<li><a class="video-tutorial-link" href="https://www.<?php echo getp();?>.com/video-tutorials-direct.htm?vfile=adding_recommended_products">Adding Recommended Products</a></li>
			<li><a class="video-tutorial-link" href="https://www.<?php echo getp();?>.com/video-tutorials-direct.htm?vfile=file_backup">Backing Up Files</a></li>
			<li><a class="video-tutorial-link" href="https://www.<?php echo getp();?>.com/video-tutorials-direct.htm?vfile=adding_shipping">Adding Shipping Methods</a></li>
			<li><a class="video-tutorial-link" href="https://www.<?php echo getp();?>.com/video-tutorials-direct.htm?vfile=adding_fields_checkout">Adding Additional Fields to Checkout</a></li>
			<li><a class="video-tutorial-link" href="https://www.<?php echo getp();?>.com/video-tutorials-direct.htm?vfile=creatingwholesalers">Creating Wholesalers (pricing groups)</a></li>
		</ul>
	</div>

	<div id="video-tutorial" style="display:none">
		<iframe src="" style="width:760px;height:620px;border:none;"></iframe>
	</div>
<?php
	}

	$taxService = Tax_ProviderFactory::getTaxService();

	if ($taxService instanceof Tax_Exactor_ExactorService && in_array($p, array('settings_exactor')))
	{
?>
<div id="exactor_euc_dialog" style="display:none;">
	<div id="exactor_euc_dialog_inner"></div>
	<div style="text-align:center;">
		<button onclick="closeSelectEUCCode()">Close</button>
	</div>
</div>
<?php
	}
?>
	<div id="QuickStartGuide" style="display:none;">
		<div id="QuickStartGuideInner"></div>
	</div>
<?php
	if (intval($auto_open_referral_dialog) == 1)
	{
?>
	<div id="ReferralDialog" style="display:none;">
		<div id="ReferralDialogInner">
			<iframe style="border:none;width:750px;height:420px;" frameBorder="0" src="https://www.cartmanual.com/referral-message/?rpid=<?php echo $referral_partner_id;?>"></iframe>
		</div>
	</div>
<?php } ?>	
	<div id="admin-loader" class="admin-loader" style="display:none;">
		<div>
			<div class="title">Please wait</div>
			<div class="message">Updating data...</div>
		</div>
	</div>
<?php
	if (Admin_Flash::hasMessages())
	{
		$translator = Framework_Translator::getInstance();

		$flashMessages = Admin_Flash::getMessages();

		foreach ($flashMessages as $flashMessage)
		{
			$flashMessageText = $flashMessage[0];
			$flashMessageType = $flashMessage[1];
?>
		<div class="flash-message" data-message-type="<?= $flashMessageType;?>" style="display:none;">
			<div sstyle="width:550px;"><?= $translator->trans($flashMessageText); ?></div>
		</div>
<?php
		}
?>
<script type="text/javascript">
	$(document).ready(function(){
		$('.flash-message').each(function(index, flashMessage){
			var messageType = $(flashMessage).attr('data-message-type');
			$.jGrowl($(flashMessage).html(), {
				life:12000,
				speed: 'slow',
				sticky: messageType == 'error',
				theme: 'alert alert-' + messageType,
				position: 'center',
				width: '300px'
			});
		});
	});
</script>
<?php
	}
 ?>
<?php if ($body == 'admin_home.php' && $intuitConnected && !$intuitConnectionActive) { ?>
	<div id="IntuitMessage" style="display:none;">
		<div style="float:left;width:91px;padding-right:10px;"><img src="images/admin/point.png"/></div>
		<div style="float:left;width:550px;">
			<h2 class="alert-error-heading">Houston, we have a problem!</h2>
			It appears your cart has lost its connection to Quickbooks. <a href="admin.php?p=settings_intuit">CLICK HERE</a> to re-connect.
			<div style="margin-top:8px;font-size:0.8em;">
				<a href="admin.php?p=settings_intuit&action=update_status&intuit_anywhere_enabled=No">Do not show this message again</a>
			</div>
		</div>
		<div style="clear:both;"></div>
	</div>
	<script type="text/javascript">
		$(document).ready(function() {
			$.jGrowl($('#IntuitMessage').html(), {
				life:12000,
				speed: 'slow',
				sticky: true,
				theme: 'alert alert-error',
				position: 'center'
			});
		});
	</script>
<?php } ?>
<?php

	if ($isTrial)
	{
		?>
<script type="text/javascript">
adroll_adv_id = "3EI76HPGLBHF5N4QRS45KJ";
adroll_pix_id = "XI2WQWDYCNDPRNEFTYDYVI";
(function () {
var oldonload = window.onload;
window.onload = function(){
   __adroll_loaded=true;
   var scr = document.createElement("script");
   var host = (("https:" == document.location.protocol) ? "https://s.adroll.com" : "http://a.adroll.com");
   scr.setAttribute('async', 'true');
   scr.type = "text/javascript";
   scr.src = host + "/j/roundtrip.js";
   ((document.getElementsByTagName('head') || [null])[0] ||
    document.getElementsByTagName('script')[0].parentNode).appendChild(scr);
   if(oldonload){oldonload()}};
}());
</script>
		<?php
	}
	
	if ($settings['AdminShowTrialForm'] == '1')
	{
		if ($isTrial && is_file('trial/form.php'))
		{
			include('trial/form.php');
		}
	}

	if (!$isTrial || $settings['AdminShowTrialForm'] != '1')
	{
		?>
<script type="text/javascript">
$(document).ready(function(){
	if ($('#intuit-quickstart').size() > 0) $('#intuit-quickstart').dialog('open');
});
</script>
		<?php
	}
?>
</body>
</html>

