<?php

	if (!defined("ENV")) exit();
	
	$action = isset ($_REQUEST["action"]) ? $_REQUEST["action"] : null;
	
	switch ($action)
	{
		/**
		 * Save active 
		 */
		case "activate" :
		{
			$payment_method_id = isset ($_REQUEST["payment_method_id"]) ? $_REQUEST["payment_method_id"] : "";
			
			if ($payment_method_id != "")
			{
				$db->query("UPDATE `".DB_PREFIX."payment_methods` SET active='Yes' WHERE id='".$db->escape($payment_method_id)."'");
			}
			else
			{
				echo json_encode(array('result'=>0));
				exit;
			}
			// note: do not break here, do saveSettings as well
		}
		
		/**
		 * Save settings 
		 */
		case "saveSettings" :
		{
			$form = isset($_REQUEST["form"]) ? is_array($_REQUEST["form"]) ? $_REQUEST["form"] : array() : array();
			
			foreach ($form as $name=>$value)
			{
				$db->query($q = "UPDATE `".DB_PREFIX."settings` SET value='".$db->escape($value)."' WHERE name='".$db->escape($name)."'");
			}	
				
			break;
		}
		
		/**
		 * Disable 
		 */
		case "disable" :
		{
			$payment_method_id = isset ($_REQUEST["payment_method_id"]) ? $_REQUEST["payment_method_id"] : "";
			if ($payment_method_id != "")
			{
				$db->query("UPDATE `".DB_PREFIX."payment_methods` SET active='Yes' WHERE id='".$db->escape($payment_method_id)."'");
			}
			else
			{
				echo json_encode(array('result'=>0));
				exit;
			}
		}
	}
	
	/**
	 * Check for PayPal Express Checkout Boarding
	 */
	if (!DEMO_LOCK && (AccessManager::checkAccess('PAYMENT_PAYPAL_BASIC') || AccessManager::checkAccess('PAYMENT_PAYPAL_ALL')) && 
		((in_array($_REQUEST["action"], array('activate')) && in_array($payment_method_id, array('paypalipn', 'paypalpro', 'paypalpflink', 'paypaladv'))) || isset($_POST["paypalEC"]))
	)
	{
		$ecParams = array(
			"paypalec_Email" => isset($_POST["paypalECEmail"]) ? $_POST["paypalECEmail"] : $admin['email'],
			"paypalec_Payment_Action" => "Sale"
		);

		foreach ($ecParams as $ecOptionName=>$ecOptionValue)
		{
			$db->query("UPDATE ".DB_PREFIX."settings SET value='".$db->escape($ecOptionValue)."' WHERE name='".$db->escape($ecOptionName)."'");
		}
		
		$db->reset();
		$db->assignStr("active", "Yes");
		$db->update(DB_PREFIX."payment_methods", "WHERE id='paypalec'");
	}
	
	echo json_encode(array('result'=>1));

	