<?php
	if (!defined("ENV")) exit();

	loadJS("cd_attribute.js");
	pageHeader("Global Product Attributes", "", "icb-checkmark");
	
	pageNote(array(
		array("class"=>"ic-add", "text"=>"<b>Click to create a new Product Attribute</b>", "url"=>"admin.php?p=products_attribute&mode=insert", "visible"=>true)
	));
	
	$db->query("SELECT * FROM ".DB_PREFIX."global_attributes ORDER BY name");
	
	if ($db->numRows()>0)
	{
?>
<table cellpadding="0" cellspacing="0" border="0" width="100%" class="admin-list-table">
	<thead>
		<tr>
			<th class="icon"></th>
			<th>Attribute Name</th>
			<th style="width:200px;">Attribute Caption</th>
			<th style="width:100px;">Type</th>
			<th style="width:100px;">Visible</th>
			<th style="width:100px;"></th>
		</tr>
	</thead>
	<tbody>
<?php
		while ($db->moveNext())
		{
?>
		<tr>
			<td class="icon"><img src="images/icons/a/checkmark.png"/></td>
			<td><a href="admin.php?p=products_attribute&mode=update&gaid=<?=$db->col["gaid"]?>"><?=htmlspecialchars($db->col["name"])?></a></td>
			<td><a href="admin.php?p=products_attribute&mode=update&gaid=<?=$db->col["gaid"]?>"><?=htmlspecialchars($db->col["caption"])?></a></td>
			<td><?=ucfirst($db->col["attribute_type"])?></td>
			<td><?=$db->col["is_active"]?></td>
			<td class="text-align-right">
				<a href="admin.php?p=products_attribute&mode=update&gaid=<?=$db->col["gaid"]?>"><img src="images/icons/a/pencil.png" border="0" title="Edit Attribute"></a>
				<a href="javascript:ConfirmDeleteAttribute(<?=$db->col["gaid"]?>)"><img src="images/icons/a/delete.png" border="0" title="Delete Attribute"></a>
			</td>
		</tr>
<?php
		}
?>
	</tbody>
</table>
<?php
	}
	else
	{
		pageNote(array(
			array("class"=>"ic-info", "text"=>"No attributes have been entered yet.", "url"=>"", "visible"=>true)
		));
	}
	