<?php
	if (!defined("ENV")) exit();

// load our user object
$db->query('
	SELECT pr.review_title, pr.rating, pr.review_text, u.fname, u.lname, u.email
	FROM '.DB_PREFIX.'products_reviews pr
	JOIN '.DB_PREFIX.'users u ON u.uid = pr.user_id AND u.removed="No"
	WHERE pr.id = '.intval($rid));

if ($review = $db->moveNext())
{
	// print the profile output;
	$review = array(
		'reviewer_fname' => htmlspecialchars($review['fname']),
		'reviewer_lname' => htmlspecialchars($review['lname']),
		'review_rating' => $review['rating'],
		'review_title' => htmlspecialchars($review['review_title']),
		'review_text' => nl2br(htmlspecialchars($review['review_text']))
	);
	echo json_encode($review);
	exit;
}
else
{
	print '
	<div id="admin_product_review">
		<h1>Encountered Error</h1>
		<p>A review does not exist with the ID given. Please check the review ID and try again.</p>
	</div>
	';
}