<?php
	if (!defined("ENV")) exit();

	$where = "id IN (".implode(',', $_POST['reviews']).") LIMIT ".count($_POST['reviews']);

	if (wasClicked('delete_reviews') && !DEMO_LOCK)
	{
		$db->query("DELETE FROM ".DB_PREFIX."products_reviews WHERE ".$where);
	}

	if (wasClicked('apply_changes') && !DEMO_LOCK)
	{
		if ($_POST['set_is_visible'] != '' || $_POST['set_approved'] != '')
		{
			$db->reset();
			// set visibility status
			if ($_POST['set_is_visible'] != '')
			{
				$db->assignStr("is_visible", $_POST['set_is_visible']);
			}
			// set approval status
			if ($_POST['set_approved'] != '')
			{
				$db->assignStr("date_approved", "NOW()");
				$db->assignStr("approved", $_POST['set_approved']);
			}	
			$db->update(DB_PREFIX."products_reviews", "WHERE ".$where);
		}
		
		/**
		 * Update products rating
		 */
		require_once("content/classes/class.ddm_product_reviews.php");
		$reviews = new Ddm_Product_Reviews($db, $settings);
		
		$db->query("SELECT pid FROM ".DB_PREFIX."products_reviews", "WHERE ".$where." GROUP BY pid");
		$products = $db->getRecords();
		foreach ($products as $product)
		{
			$rating = $reviews->getProductRating($product["pid"]);
			$reviewsCount = $reviews->getReviewsCount($product["pid"]);
			$db->reset();
			$db->assignStr("rating", $rating["rating"]);
			$db->assignStr("reviews_count", $rating["total_reviews"]);
			$db->update(DB_PREFIX."products", "WHERE pid='".intval($product["pid"])."'");
		}
	}

	header('Location: ?'.$_SESSION["admin_search_product_reviews_url"]);