$(document).ready(function(){
	$("#selectCategories").change(function(){
		UpdateAvailableProducts();
	});

	$('#selectCategories').change();
        UpdateAssignedProductsList();

        $('#btnAddProduct').click(function(){
		$("#btnAddProduct").attr("disabled", "disabled");
		$("#btnRemoveProduct").attr("disabled", "disabled");
		$("#btnSaveGroup").attr("disabled", "disabled");
		var group_id = $("#group_id").val();
		var selectedProducts = [];
		$('#selectProducts :selected').each(function(i, selectedOption){
			selectedProducts[i] = $(selectedOption).val();
		});

		$.getJSON("admin.php?chart=true&p=products_group&mode=assignProducts&group_id=" + escape(group_id) + '&products=' + escape(selectedProducts), 
			function(data){
				if (data.result)
				{
					UpdateAssignedProductsList();
					UpdateAvailableProducts();
				}
				$("#btnAddProduct").removeAttr("disabled");
				$("#btnRemoveProduct").removeAttr("disabled");
				$("#btnSaveGroup").removeAttr("disabled");
				$("#btnSaveGroup").html("Save Group");
			});
        })
        $('#btnRemoveProduct').click(function(){
		$("#btnAddProduct").attr("disabled", "disabled");
		$("#btnRemoveProduct").attr("disabled", "disabled");
		$("#btnSaveGroup").attr("disabled", "disabled");
		var group_id = $("#group_id").val();
		var selectedProducts = [];
		$('#selectedProducts :selected').each(function(i, selectedOption){
			selectedProducts[i] = $(selectedOption).val();
		});

		$.getJSON("admin.php?chart=true&p=products_group&mode=unassignProducts&group_id=" + escape(group_id) + '&products=' + escape(selectedProducts), function(data){
                    if (data.result)
                    {
                        UpdateAssignedProductsList();
                        UpdateAvailableProducts();
                    }
                    $("#btnAddProduct").removeAttr("disabled");
                    $("#btnRemoveProduct").removeAttr("disabled");
                    $("#btnSaveGroup").removeAttr("disabled");
                    $("#btnSaveGroup").html("Save Group");
		});
        })

        $('#btnSaveGroup').click(function(){
                $("#btnSaveGroup").html("Saving...");
		$("#btnAddProduct").attr("disabled", "disabled");
		$("#btnRemoveProduct").attr("disabled", "disabled");
		$("#btnSaveGroup").attr("disabled", "disabled");

                $("#btnAddProduct").removeAttr("disabled");
                $("#btnRemoveProduct").removeAttr("disabled");
                $("#btnSaveGroup").html("Saved");
                window.location = "admin.php?p=products_groups&lastTab=Existing";
        })

        function UpdateAvailableProducts()
        {
		var group_id = $("#group_id").val();
		var selectedCategories = [];
		$('#selectCategories :selected').each(function(i, selectedOption){
			selectedCategories[i] = $(selectedOption).val();
		});
                $.getJSON("admin.php?chart=true&p=products_group&group_id="+group_id+"&mode=getProducts&categories=" + escape(selectedCategories), function(data){
                        $("#selectProducts").html("");
                        $(data.products).each(function(i, product){
                                var o = $("<option></option>").val(product.pid).html(product.title);
                                $("#selectProducts").append(o);
                        });
                });
        }
        function UpdateAssignedProductsList()
        {
            var group_id = $("#group_id").val();
            $.getJSON("admin.php?chart=true&p=products_group&mode=getAssignedProducts&group_id=" + escape(group_id), function(data){
                $("#selectedProducts").html("");
                $(data.products).each(function(i, product){
                        var o = $("<option></option>").val(product.pid).html(product.title);
                        $("#selectedProducts").append(o);
                });
            });
        }
});