$(document).ready(function(){

	if ($("#dialog_stamps_scan_result").length  > 0)
	{
		$("#dialog_stamps_scan_result").dialog({
			autoOpen: true,
			width: 500,
			height: 600,
			title: 'SCAN Generation Result',
			modal: true,
			resizable: false,
			buttons: [
				{
					text: "Print",
					click: function(){
						window.frames["dialog_stamps_scan_result_preview_iframe"].focus();
						window.frames["dialog_stamps_scan_result_preview_iframe"].print();
					}
				},
				{
					text: "Close",
					click: function(){
						$("#dialog_stamps_scan_result").dialog('close');
					}
				}
			],
			open : function(){
				$('<iframe id="dialog_stamps_scan_result_preview_iframe" name="dialog_stamps_scan_result_preview_iframe" style="width:100%;height:460px;border:none;"></iframe>').appendTo('#dialog_stamps_scan_result_preview');
				$('#dialog_stamps_scan_result_preview_iframe').load(function(){
					var iframeBody = $('#dialog_stamps_scan_result_preview_iframe').contents().find('body');
					$(iframeBody).html('');
					$("#dialog_stamps_scan_result_preview img").each(function(index, img){
						var scanImgSrc = $(img).attr('src');
						$(iframeBody).append('<div style="page-break-after:always"><img style="width:100%;" src="' + scanImgSrc + '"></div>');
					});
				});
				$('#dialog_stamps_scan_result_preview_iframe').attr('src', 'about:blank');
			}
		});
	}

	$('.link_stamps_scan_search_view').each(function(){
		$(this).click(function(e){
			e.stopPropagation();

			var dialogId = $(this).attr('href');
			dialogId = dialogId.substr(1);

			$('#' + dialogId).dialog({
				autoOpen: true,
				width: 500,
				height: 600,
				title: 'SCAN Form Preview',
				modal: true,
				resizable: false,
				buttons: [
					{
						text: 'Print',
						click: function(){
							window.frames[dialogId + '_iframe'].focus();
							window.frames[dialogId + '_iframe'].print();
						}
					},
					{
						text: 'Close',
						click: function(){
							$('#' + dialogId).dialog('close');
						}
					}
				],
				open : function(){
					if ($('#' + dialogId + '_iframe').length == 0)
					{
						$('<iframe id="' + dialogId + '_iframe" name="' + dialogId + '_iframe" style="width:100%;height:460px;border:none;"></iframe>').appendTo('#' + dialogId + '_preview');
						$('#' + dialogId + '_iframe').load(function(){
							var iframeBody = $('#' + dialogId + '_iframe').contents().find('body');
							$(iframeBody).html('');
							$('#' + dialogId +'_preview img').each(function(index, img){
								var scanImgSrc = $(img).attr('src');
								$(iframeBody).append('<div style="page-break-after:always"><img style="width:100%;" src="' + scanImgSrc + '"></div>');
							});
						});
						$('#' + dialogId + '_iframe').attr('src', 'about:blank');
					}
				}
			});

			return false;
		});
	});
});
