<?php

/**
 * Stamps.com Repository
 */

class DataAccess_StampsRepository extends DataAccess_Repository
{
	/**
	 * @param $date
	 * @return mixed
	 */
	public function getScanFormsByDate($date)
	{
		$db = self::$db;

		$scanForms = $db->selectAll('SELECT * FROM '.DB_PREFIX.'shipping_scan_forms WHERE scan_form_date="'.$db->escape($date).'" AND scan_form_source="stamps"');

		if ($scanForms)
		{
			foreach ($scanForms as $key => $scanForm)
			{
				$scanForms[$key]['scan_form_url'] = unserialize($scanForms[$key]['scan_form_url']);
			}

			return $scanForms;
		}

		return false;
	}

	/**
	 * @param $scanFormData
	 */
	public function saveScanForm($scanFormData)
	{
		$db = self::$db;
		$db->reset();
		$db->assignStr('scan_form_source', 'stamps');
		$db->assignStr('scan_form_date', $scanFormData['date']);
		$db->assignStr('scan_form_code', $scanFormData['code']);
		$db->assignStr('scan_form_url', serialize($scanFormData['urls']));
		$db->insert(DB_PREFIX.'shipping_scan_forms');
	}
}